Stepper

Bootstrap 5 Stepper / Wizard component

Responsive stepper built with Bootstrap 5. Form wizard, vertical stepper, multi step form validation, optional step, mobile stepper & more

Stepper is a component that displays content as a process with defined by user milestones. This is a great solution for a variety of registration forms, where you don't want to scare the user with lots of fields and questions.

In this documentation, you can find examples of form wizard, vertical stepper, horizontal stepper, multi step form, mobile stepper, validation & more.

Note: Read the API tab to find all available options and advanced customization

Required ES init: Stepper *
* UMD autoinits are enabled by default. This means that you don't need to initialize the component manually. However if you are using MDBootstrap ES format then you should pass the required components to the initMDB method.

Basic example

You can automatically initialize the stepper component using data-mdb-stepper-init attribute.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <ul class="stepper" data-mdb-stepper-init>
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                  incididunt ut labore et dolore magna aliqua
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                  ex ea commodo consequat
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper });
          
        
    

Change steps using external elements

To go to the next or previous step, you can use the nextStep and prevStep methods. You can also choose a specific step using the changeStep method by entering the step index.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <div class="mb-3">
              <button id="prev-step" class="btn btn-primary" data-mdb-ripple-init>prev</button>
              <button id="step-1" class="btn btn-primary" data-mdb-ripple-init>step1</button>
              <button id="step-2" class="btn btn-primary" data-mdb-ripple-init>step2</button>
              <button id="step-3" class="btn btn-primary" data-mdb-ripple-init>step3</button>
              <button id="next-step" class="btn btn-primary" data-mdb-ripple-init>next</button>
            </div>
            <div>
              <ul class="stepper" id="stepper-buttons">
                <li class="stepper-step stepper-active">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">1</span>
                    <span class="stepper-head-text">step1</span>
                  </div>
                  <div class="stepper-content py-3">
                    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                    incididunt ut labore et dolore magna aliqua
                  </div>
                </li>
                <li class="stepper-step">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">2</span>
                    <span class="stepper-head-text">step2</span>
                  </div>
                  <div class="stepper-content py-3">
                    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat
                  </div>
                </li>
                <li class="stepper-step">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">3</span>
                    <span class="stepper-head-text">step3</span>
                  </div>
                  <div class="stepper-content py-3">
                    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur
                  </div>
                </li>
              </ul>
            </div>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Ripple, initMDB } from "mdb-ui-kit";
            initMDB({ Ripple });

            const stepper = new Stepper(document.getElementById('stepper-buttons'));

            document.getElementById('next-step').addEventListener('click', () => {
              stepper.nextStep();
            });

            document.getElementById('prev-step').addEventListener('click', () => {
              stepper.prevStep();
            });

            document.getElementById('step-1').addEventListener('click', () => {
              stepper.changeStep(0);
            });

            document.getElementById('step-2').addEventListener('click', () => {
              stepper.changeStep(1);
            });

            document.getElementById('step-3').addEventListener('click', () => {
              stepper.changeStep(2);
            });
          
        
    
        
            
          const stepper = new mdb.Stepper(document.getElementById('stepper-buttons'));

          document.getElementById('next-step').addEventListener('click', () => {
            stepper.nextStep();
          });

          document.getElementById('prev-step').addEventListener('click', () => {
            stepper.prevStep();
          });

          document.getElementById('step-1').addEventListener('click', () => {
            stepper.changeStep(0);
          });

          document.getElementById('step-2').addEventListener('click', () => {
            stepper.changeStep(1);
          });

          document.getElementById('step-3').addEventListener('click', () => {
            stepper.changeStep(2);
          });
        
        
    

Linear stepper

If you want to use basic validation before advancing to the next step you can set data-mdb-stepper-linear="true"

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <ul class="stepper" data-mdb-stepper-init data-mdb-stepper-linear="true">
              <form class="needs-validation stepper-form" novalidate>
                <li class="stepper-step stepper-active">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">1</span>
                    <span class="stepper-head-text">step1</span>
                  </div>
                  <div class="stepper-content py-3">
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="linear-stepper-input-1" class="form-control" required />
                      <label class="form-label" for="linear-stepper-input-1">step 1</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </div>
                </li>
                <li class="stepper-step">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">2</span>
                    <span class="stepper-head-text">step2</span>
                  </div>
                  <div class="stepper-content py-3">
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="linear-stepper-input-2" class="form-control" required />
                      <label class="form-label" for="linear-stepper-input-2">step 2</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </div>
                </li>
                <li class="stepper-step">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">3</span>
                    <span class="stepper-head-text">step3</span>
                  </div>
                  <div class="stepper-content py-3">
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="linear-stepper-input-3" class="form-control" required />
                      <label class="form-label" for="linear-stepper-input-3">step 3</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                    <button class="btn btn-primary" type="submit" data-mdb-ripple-init>Submit</button>
                  </div>
                </li>
              </form>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Input, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper, Input });
          
        
    

No editable stepper

You can set data-mdb-stepper-no-editable="true" to prevent editing a completed step.

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <ul class="stepper" data-mdb-stepper-init data-mdb-stepper-no-editable="true">
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="no-editable-stepper-input-1" class="form-control" required />
                      <label class="form-label" for="no-editable-stepper-input-1">step 1</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="no-editable-stepper-input-2" class="form-control" required />
                      <label class="form-label" for="no-editable-stepper-input-2">step 2</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="no-editable-stepper-input-3" class="form-control" required />
                      <label class="form-label" for="no-editable-stepper-input-3">step 3</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Input, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper, Input });
          
        
    

Vertical stepper

Set data-mdb-stepper-type="vertical" to use the vertical view.

  • 1 step1
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 2 step2
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 3 step3
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
        
            
            <ul class="stepper" data-mdb-stepper-init data-mdb-stepper-type="vertical">
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  <span>
                    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque
                    dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
                  </span>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  <span>
                    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque
                    dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
                  </span>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  <span>
                    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque
                    dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
                  </span>
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper });
          
        
    

Mobile stepper

Set data-mdb-stepper-type="mobile" to use mobile view.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <ul class="stepper" data-mdb-stepper-init data-mdb-stepper-type="mobile">
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                  incididunt ut labore et dolore magna aliqua
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                  ex ea commodo consequat
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper });
          
        
    

Mobile stepper progress bar

if the stepper contains more than 4 steps, the progress bar will be displayed by default instead of dots. You can edit the step limit with the stepper-mobile-bar-breakpoint attribute.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <ul class="stepper" data-mdb-stepper-init data-mdb-stepper-type="mobile">
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                  incididunt ut labore et dolore magna aliqua
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                  ex ea commodo consequat
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper });
          
        
    

Stepper with gesture support

Adding Touch Swipe utils to the stepper enables changing the stepper step using gestures.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <ul class="stepper" data-mdb-stepper-init>
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                  incididunt ut labore et dolore magna aliqua
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                  ex ea commodo consequat
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                  fugiat nulla pariatur
                </div>
              </li>
            </ul>
            
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Touch, initMDB } from "mdb-ui-kit";
            initMDB({ Stepper });

            const stepper = document.querySelector('.stepper')

            const stepperInstance = Stepper.getOrCreateInstance(stepper);
            const touchSwipeLeftRight = new Touch(stepper, 'swipe', {
              threshold: 100
            });

            stepper.addEventListener('swipeleft', () => {
              stepperInstance.nextStep();
            });
            stepper.addEventListener('swiperight', () => {
              stepperInstance.prevStep();
            });
            
        
    
        
            
            // Initialization for ES Users
            const stepper = document.querySelector('.stepper')

            const stepperInstance = mdb.Stepper.getOrCreateInstance(stepper);
            const touchSwipeLeftRight = new mdb.Touch(stepper, 'swipe', {
              threshold: 100
            });

            stepper.addEventListener('swipeleft', () => {
              stepperInstance.nextStep();
            });
            stepper.addEventListener('swiperight', () => {
              stepperInstance.prevStep();
            });
            
        
    

Optional step

You can mark a step as optional by adding data-mdb-stepper-optional="true" to it.

  • 1 step1
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 2 step2
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 3 step3
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
        
            
            <ul class="stepper" data-mdb-stepper-init>
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  <span>
                    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque
                    dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
                  </span>
                </div>
              </li>
              <li class="stepper-step" data-mdb-stepper-optional="true">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  <span>
                    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque
                    dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
                  </span>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  <span>
                    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque
                    dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
                  </span>
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper });
          
        
    

Custom icons

if you want to use an icon instead of a step number you can do it by placing it inside <span class="stepper-head-icon"></span>

  • step1
    invalid
  • step2
    invalid
  • step3
    invalid
        
            
            <ul class="stepper" data-mdb-stepper-init>
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">
                    <i class="fas fa-user"></i>
                  </span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="custom-icon-input-1" class="form-control" required />
                      <label class="form-label" for="custom-icon-input-1">step 1</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">
                    <i class="fas fa-envelope"></i>
                  </span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="custom-icon-input-2" class="form-control" required />
                      <label class="form-label" for="custom-icon-input-2">step 2</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">
                    <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                  </span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="custom-icon-input-3" class="form-control" required />
                      <label class="form-label" for="custom-icon-input-3">step 3</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Input, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper, Input });
          
        
    

Form wizard

An example of so-called "Form wizard" with multiple inputs on each step.

  • 1 step1
    invalid
    invalid
  • 2 step2
    invalid
    invalid
    invalid
    invalid
  • 3 step3
        
            
            <!-- Form wizrd -->
            <div>
              <!-- Steps -->
              <ul class="stepper" id="stepper-form-example" data-mdb-stepper-linear="true">
                <form class="needs-validation stepper-form">
                  <!-- First step -->
                  <li class="stepper-step stepper-active">
                    <div class="stepper-head">
                      <span class="stepper-head-icon">1</span>
                      <span class="stepper-head-text">step1</span>
                    </div>
                    <div class="stepper-content py-3">
                      <div class="form-outline mb-4" data-mdb-input-init>
                        <input type="text" id="stepper-form-first-name" class="form-control" required/>
                        <label class="form-label" for="stepper-form-first-name">First name<small class="text-muted">(required)</small></label>
                        <div class="invalid-feedback">invalid</div>
                      </div>

                      <div class="form-outline mb-4" data-mdb-input-init>
                        <input type="text" id="stepper-form-last-name" class="form-control" required/>
                        <label class="form-label" for="stepper-form-last-name">Last name<small class="text-muted">(required)</small></label>
                        <div class="invalid-feedback">invalid</div>
                      </div>

                      <div class="form-outline mb-4" data-mdb-input-init>
                        <input type="text" id="stepper-form-last-name" class="form-control" />
                        <label class="form-label" for="stepper-form-last-name">Nickname<small class="text-muted">(optional)</small></label>
                      </div>
                    </div>
                  </li>
                  <!-- First step -->

                  <!-- Second step -->
                  <li class="stepper-step">
                    <div class="stepper-head">
                      <span class="stepper-head-icon">2</span>
                      <span class="stepper-head-text">step2</span>
                    </div>
                    <div class="stepper-content py-3">
                      <div class="form-outline mb-4" data-mdb-input-init>
                        <input type="text" id="form6Example3" class="form-control" required />
                        <label class="form-label" for="form6Example3">Company name<small class="text-muted">(required)</small></label>
                        <div class="invalid-feedback">invalid</div>
                      </div>

                      <div class="form-outline mb-4" data-mdb-input-init>
                        <input type="text" id="form6Example4" class="form-control" required />
                        <label class="form-label" for="form6Example4">Address<small class="text-muted">(required)</small></label>
                        <div class="invalid-feedback">invalid</div>
                      </div>

                      <div class="form-outline mb-4" data-mdb-input-init>
                        <input type="email" id="form6Example5" class="form-control" required />
                        <label class="form-label" for="form6Example5">Email<small class="text-muted">(required)</small></label>
                        <div class="invalid-feedback">invalid</div>
                      </div>

                      <div class="form-outline mb-4" data-mdb-input-init>
                        <input type="number" id="form6Example6" class="form-control" />
                        <label class="form-label" for="form6Example6">Phone<small class="text-muted">(optional)</small></label>
                        <div class="invalid-feedback">invalid</div>
                      </div>
                    </div>
                  </li>
                  <!-- Second step -->

                  <!-- Third step -->
                  <li class="stepper-step">
                    <div class="stepper-head">
                      <span class="stepper-head-icon">3</span>
                      <span class="stepper-head-text">step3</span>
                    </div>
                    <div class="stepper-content py-3">
                      <div class="form-outline mb-4" data-mdb-input-init>
                        <textarea class="form-control" id="form6Example7" rows="4"></textarea>
                        <label class="form-label" for="form6Example7">Additional information</label>
                      </div>

                      <div class="form-check d-flex justify-content-center mb-4">
                        <input class="form-check-input me-2" type="checkbox" value="" id="form6Example8" checked/>
                        <label class="form-check-label" for="form6Example8">Create an account?</label>
                      </div>

                      <button type="submit" class="btn btn-success btn-block mb-4" data-mdb-ripple-init>Place order</button>
                    </div>
                  </li>
                  <!-- Third step -->
                </form>
              </ul>
              <!-- Steps -->

              <!-- Buttons -->
              <div class="d-flex justify-content-center px-3">
                <button id="form-example-prev-step" class="btn btn-primary w-100 me-2" data-mdb-ripple-init>Previous step</button>
                <button id="form-example-next-step" class="btn btn-primary w-100" data-mdb-ripple-init>Next step</button>
              </div>
              <!-- Buttons -->
            </div>
            <!-- Form wizrd -->
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Input, Ripple, initMDB } from "mdb-ui-kit";
            initMDB({ Input, Ripple });

            const stepper = new Stepper(document.getElementById('stepper-form-example'));

            document.getElementById('form-example-next-step').addEventListener('click', () => {
              stepper.nextStep();
            });

            document.getElementById('form-example-prev-step').addEventListener('click', () => {
              stepper.prevStep();
            });
          
        
    
        
            
          const stepper = new mdb.Stepper(document.getElementById('stepper-form-example'));

          document.getElementById('form-example-next-step').addEventListener('click', () => {
            stepper.nextStep();
          });

          document.getElementById('form-example-prev-step').addEventListener('click', () => {
            stepper.prevStep();
          });
        
        
    

Toggle to vertical or mobile on smaller screens

If you want to change the view from horizontal to vertical or mobile with smaller screens you can use the data-mdb-stepper-vertical-breakpoint and data-mdb-stepper-mobile-breakpoint attribute specifying the number of pixels at which the stepper should change to vertical or mobile. You can resize the browser window to test it.

  • step1
    invalid
  • step2
    invalid
  • step3
    invalid
        
            
            <ul
              class="stepper"
              data-mdb-stepper-init
              data-mdb-stepper-vertical-breakpoint="768"
              data-mdb-stepper-mobile-breakpoint="400"
            >
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">
                    <i class="fas fa-user"></i>
                  </span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="toggle-to-vertical-input-1" class="form-control" required />
                      <label class="form-label" for="toggle-to-vertical-input-1">step 1</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">
                    <i class="fas fa-envelope"></i>
                  </span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="toggle-to-vertical-input-2" class="form-control" required />
                      <label class="form-label" for="toggle-to-vertical-input-2">step 2</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step" data-mdb-stepper-optional="true">
                <div class="stepper-head">
                  <span class="stepper-head-icon">
                    <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                  </span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="toggle-to-vertical-input-3" class="form-control" required />
                      <label class="form-label" for="toggle-to-vertical-input-3">step 3</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Input, initMDB } from "mdb-ui-kit";

            initMDB({ Stepper, Input });
          
        
    

Events

Stepper emits events after successful step validation, failed step validation, before and after changing to another step. Check the browser console and try to change the step to see the result.

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <ul class="stepper" data-mdb-stepper-init data-mdb-stepper-linear="true">
              <li class="stepper-step stepper-active">
                <div class="stepper-head">
                  <span class="stepper-head-icon">1</span>
                  <span class="stepper-head-text">step1</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="events-input-1" class="form-control" required />
                      <label class="form-label" for="events-input-1">step 1</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">2</span>
                  <span class="stepper-head-text">step2</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="events-input-2" class="form-control" required />
                      <label class="form-label" for="events-input-2">step 2</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
              <li class="stepper-step">
                <div class="stepper-head">
                  <span class="stepper-head-icon">3</span>
                  <span class="stepper-head-text">step3</span>
                </div>
                <div class="stepper-content py-3">
                  <form class="needs-validation" novalidate>
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="events-input-3" class="form-control" required />
                      <label class="form-label" for="events-input-3">step 3</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </form>
                </div>
              </li>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Input, initMDB } from "mdb-ui-kit";
          
            initMDB({ Stepper, Input });

            document.querySelector('#linear-stepper .stepper').addEventListener('stepValid.mdb.stepper', (e) => {
              console.log('stepValid', e);
            });

            document.querySelector('#linear-stepper .stepper').addEventListener('stepInvalid.mdb.stepper', (e) => {
              console.log('stepInvalid', e);
            });

            document.querySelector('#linear-stepper .stepper').addEventListener('stepChange.mdb.stepper', (e) => {
              console.log('stepChange', e);
            });

            document.querySelector('#linear-stepper .stepper').addEventListener('stepChanged.mdb.stepper', (e) => {
              console.log('stepChanged', e);
            });
          
        
    
        
            
          document.querySelector('#linear-stepper .stepper').addEventListener('stepValid.mdb.stepper', (e) => {
            console.log('stepValid', e);
          });

          document.querySelector('#linear-stepper .stepper').addEventListener('stepInvalid.mdb.stepper', (e) => {
            console.log('stepInvalid', e);
          });

          document.querySelector('#linear-stepper .stepper').addEventListener('stepChange.mdb.stepper', (e) => {
            console.log('stepChange', e);
          });

          document.querySelector('#linear-stepper .stepper').addEventListener('stepChanged.mdb.stepper', (e) => {
            console.log('stepChanged', e);
          });
        
        
    

Add custom validation

You can use the stepChange.mdb.stepper event to use your own validation.

  • 1 step1
    Password should have 5 or more characters
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <ul class="stepper" data-mdb-stepper-init data-mdb-stepper-linear="true">
              <form class="needs-validation stepper-form" novalidate>
                <li class="stepper-step stepper-active">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">1</span>
                    <span class="stepper-head-text">step1</span>
                  </div>
                  <div class="stepper-content py-3">
                    <div class="form-outline" data-mdb-input-init>
                      <input type="password" id="custom-validation-input-1" class="form-control" required />
                      <label class="form-label" for="custom-validation-input-1">password</label>
                      <div class="invalid-feedback">Password should have 5 or more characters</div>
                    </div>
                  </div>
                </li>
                <li class="stepper-step">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">2</span>
                    <span class="stepper-head-text">step2</span>
                  </div>
                  <div class="stepper-content py-3">
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="custom-validation-input-2" class="form-control" required />
                      <label class="form-label" for="custom-validation-input-2">step 2</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </div>
                </li>
                <li class="stepper-step">
                  <div class="stepper-head">
                    <span class="stepper-head-icon">3</span>
                    <span class="stepper-head-text">step3</span>
                  </div>
                  <div class="stepper-content py-3">
                    <div class="form-outline" data-mdb-input-init>
                      <input type="text" id="custom-validation-input-3" class="form-control" required />
                      <label class="form-label" for="custom-validation-input-3">step 3</label>
                      <div class="invalid-feedback">invalid</div>
                    </div>
                  </div>
                </li>
              </form>
            </ul>
          
        
    
        
            
            // Initialization for ES Users
            import { Stepper, Input, initMDB } from "mdb-ui-kit";
          
            initMDB({ Stepper, Input });

            document.querySelector('.stepper .stepper-step').addEventListener('stepChange.mdb.stepper', (e) => {
              const input = e.target.querySelector('.stepper-content input[type="password"]');
              const inputLenght = input.value.length;
              if (inputLenght < 5) {
                e.target.querySelector('input').setCustomValidity('Invalid');
                e.preventDefault();
              } else {
                e.target.querySelector('input').setCustomValidity('');
              }
            });
          
        
    
        
            
          document.querySelector('.stepper .stepper-step').addEventListener('stepChange.mdb.stepper', (e) => {
            const input = e.target.querySelector('.stepper-content input[type="password"]');
            const inputLenght = input.value.length;
            if (inputLenght < 5) {
              e.target.querySelector('input').setCustomValidity('Invalid');
              e.preventDefault();
            } else {
              e.target.querySelector('input').setCustomValidity('');
            }
          });
        
        
    

PAY ONCE

USE FOREVER

Hurry up ⌛ claim exclusive long term passes available only during Cyber Weeks

Stepper - API


Import

Importing components depends on how your application works. If you intend to use the MDBootstrap ES format, you must first import the component and then initialize it with the initMDB method. If you are going to use the UMD format, just import the mdb-ui-kit package.

        
            
          import { Stepper, initMDB } from "mdb-ui-kit";
          
          initMDB({ Stepper });
        
        
    
        
            
          import "mdb-ui-kit"
        
        
    

Usage

Via data attributes

Using the Stepper component doesn't require any additional JavaScript code - simply add data-mdb-stepper-init attribute to .stepper and use other data attributes to set all options. For ES format, you must first import and call the initMDB method.

        
            
          <ul class="stepper" data-mdb-stepper-init>
            ...
          </ul>
        
        
    

Via JavaScript

        
            
          const element = document.querySelector('.stepper');
          const stepper = new Stepper(element);
        
        
    
        
            
          const element = document.querySelector('.stepper');
          const stepper = new mdb.Stepper(element);
        
        
    

Via jQuery

Note: By default, MDB does not include jQuery and you have to add it to the project on your own.

        
            
          $(document).ready(() => {
            $('#stepper').stepper();
          });
        
        
    

Options

Options can be passed via data attributes or JavaScript. For data attributes, append the option name to data-mdb-, as in data-mdb-stepper-type="horizontal".

Name Type Default Description
animations Boolean true Set to false to turn off the animations displayed when step changes
stepperType String 'horizontal' Sets stepper view. Available types are: horizontal, vertical and mobile
stepperLinear Boolean false Set to true to use the linear stepper
stepperNoEditable Boolean false Set to true to block editing of the completed step
stepperHeadClick Boolean true Set to false to block the possibility of changing a step by clicking on another step
stepperActive String '' Sets a custom active class
stepperCompleted String '' Sets a custom completed class
stepperInvalid String '' Sets a custom invalid class
stepperDisabled String '' Sets a custom disabled class
stepperOptional Boolean false Sets a optional step.
stepperVerticalBreakpoint Number 0 Sets the resolution below which the stepper will switch to vertical
stepperMobileBreakpoint Number 0 Sets the resolution below which the stepper will switch to mobile
stepperMobileBarBreakpoint Number 4 Sets the step limit after which the progress bar will appear in the mobile view instead of the dots
stepperMobileNextBtn String 'NEXT' Sets custom text for the NEXT button
stepperMobileBackBtn String 'BACK' Sets custom text for the BACK button
stepperMobileStepTxt String 'step' Sets custom step value in the mobile stepper head
stepperMobileOfTxt String 'of' Sets custom of value in the mobile stepper head

Methods

Name Description Example
dispose Removes mdb.Stepper instance. stepper.dispose()
changeStep Switch to the step given as the parameter stepper.changeStep()
getInstance Static method which allows you to get the stepper instance associated to a DOM element. Stepper.getInstance(myStepperEl)
getOrCreateInstance Static method which returns the stepper instance associated to a DOM element or create a new one in case it wasn't initialized. Stepper.getOrCreateInstance(myStepperEl)
nextStep Switch to the next step stepper.nextStep()
prevStep Switch to the previous step stepper.prevStep()
resizeStepper Reset the height and view of the stepper stepper.resizeStepper()
        
            
          const myStepperEl = document.getElementById('stepper');
          const stepper = new Stepper(myStepperEl);
          stepper.nextStep();
        
        
    
        
            
          const myStepperEl = document.getElementById('stepper');
          const stepper = new mdb.Stepper(myStepperEl);
          stepper.nextStep();
        
        
    

Events

Name Description
stepChange.mdb.stepper This event is emitted before the step change takes place. By using e.preventDefault() you can implement custom validation. Information about the current and next steps can be accessed through the following properties of the emitted event: e.currentStep and e.nextStep.
stepChanged.mdb.stepper This event is emitted after the step change takes place. Information about the current and previous steps can be accessed through the following properties of the emitted event: e.currentStep and e.prevStep.
stepValid.mdb.stepper This event is emitted after successful step validation. Information about the current and next steps can be accessed through the following properties of the emitted event: e.currentStep and e.nextStep.
stepInvalid.mdb.stepper This event is emitted after unsuccessful step validation. Information about the current and next steps can be accessed through the following properties of the emitted event: e.currentStep and e.nextStep.
        
            
          const stepper = document.querySelector('.stepper');
          stepper.addEventListener('stepChange.mdb.stepper', () => {
            // do something...
          });
        
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, stepper now use local CSS variables on .stepper for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

        
            
          // .steps
          --#{$prefix}steps-transition: #{$steps-transition};

          // .steps-step
          --#{$prefix}steps-step-after-left: #{$steps-step-after-left};
          --#{$prefix}steps-step-after-width: #{$steps-step-after-width};
          --#{$prefix}steps-step-after-margin-top: #{$steps-step-after-margin-top};
          --#{$prefix}steps-step-after-bg: #{$steps-step-after-bg};

          // .steps-content
          --#{$prefix}steps-content-padding-y: #{$steps-content-padding-y};

          // .steps-head-vertical
          --#{$prefix}steps-head-vertical-padding-top: #{$steps-head-vertical-padding-top};
          --#{$prefix}steps-head-vertical-padding-x: #{$steps-head-vertical-padding-x};

          // .steps-head-icon-vertical
          --#{$prefix}steps-head-icon-vertical-margin-right: #{$steps-head-icon-vertical-margin-right};

          // .steps-head
          --#{$prefix}steps-head-line-height: #{$steps-head-line-height};
          --#{$prefix}steps-head-hover-bgc: #{$steps-head-hover-bgc};

          // .steps-head-text
          --#{$prefix}steps-head-text-color: #{$steps-head-text-color};
          --#{$prefix}steps-head-text-after-font-size: #{$steps-head-text-after-font-size};

          // .steps-head-icon
          --#{$prefix}steps-head-icon-font-size: #{$steps-head-icon-font-size};
          --#{$prefix}steps-head-icon-width: #{$steps-head-icon-width};
          --#{$prefix}steps-head-icon-height: #{$steps-head-icon-height};
          --#{$prefix}steps-head-icon-font-weight: #{$steps-head-icon-font-weight};

          // .steps-active-head-text
          --#{$prefix}steps-active-head-text-font-weight: #{$steps-active-head-text-font-weight};
          
          // .stepper
          --#{$prefix}stepper-padding-x: #{$stepper-padding-x};
          --#{$prefix}stepper-step-height: #{$stepper-step-height};
          --#{$prefix}stepper-step-head-padding-left: #{$stepper-step-head-padding-left};
          --#{$prefix}stepper-step-head-padding-right: #{$stepper-step-head-padding-right};
          --#{$prefix}stepper-step-head-height: #{$stepper-step-head-height};
          --#{$prefix}stepper-step-head-bg: #{$stepper-step-head-bg};
          --#{$prefix}stepper-step-head-margin-right: #{$stepper-step-head-margin-right};
          --#{$prefix}stepper-step-head-margin-left: #{$stepper-step-head-margin-left};
          --#{$prefix}stepper-head-icon-margin-y: #{$stepper-head-icon-margin-y};
          --#{$prefix}stepper-head-icon-margin-right: #{$stepper-head-icon-margin-right};
          --#{$prefix}stepper-vertical-step-top: #{$stepper-vertical-step-top};
          --#{$prefix}stepper-vertical-step-height: #{$stepper-vertical-step-height};
          --#{$prefix}stepper-vertical-content-padding-left: #{$stepper-vertical-content-padding-left};
          --#{$prefix}stepper-vertical-content-transition: #{$stepper-vertical-content-transition};
          --#{$prefix}stepper-vertical-head-padding-bottom: #{$stepper-vertical-head-padding-bottom};
          --#{$prefix}stepper-mobile-step-margin-y: #{$stepper-mobile-step-margin-y};
          --#{$prefix}stepper-mobile-step-head-padding-x: #{$stepper-mobile-step-head-padding-x};
          --#{$prefix}stepper-mobile-head-icon-height: #{$stepper-mobile-head-icon-height};
          --#{$prefix}stepper-mobile-head-icon-width: #{$stepper-mobile-head-icon-width};
          --#{$prefix}stepper-mobile-content-top: #{$stepper-mobile-content-top};
          --#{$prefix}stepper-mobile-active-head-icon-bg: #{$stepper-mobile-active-head-icon-bg};
          --#{$prefix}stepper-mobile-completed-head-icon-bg: #{$stepper-mobile-completed-head-icon-bg};
          --#{$prefix}stepper-head-icon-bg: #{$stepper-head-icon-bg};
          --#{$prefix}stepper-head-icon-color: #{$stepper-head-icon-color};
          --#{$prefix}stepper-completed-head-icon-bg: #{$stepper-completed-head-icon-bg};
          --#{$prefix}stepper-completed-head-icon-color: #{$stepper-completed-head-icon-color};
          --#{$prefix}stepper-active-head-icon-bg: #{$stepper-active-head-icon-bg};
          --#{$prefix}stepper-active-head-icon-color: #{$stepper-active-head-icon-color};
          --#{$prefix}stepper-invalid-head-icon-bg: #{$stepper-invalid-head-icon-bg};
          --#{$prefix}stepper-invalid-head-icon-color: #{$stepper-invalid-head-icon-color};
          --#{$prefix}stepper-disabled-head-color: #{$stepper-disabled-head-color};
          --#{$prefix}stepper-disabled-head-icon-bg: #{$stepper-disabled-head-icon-bg};
          --#{$prefix}stepper-disabled-head-icon-color: #{$stepper-disabled-head-icon-color};
          --#{$prefix}stepper-mobile-head-padding-y: #{$stepper-mobile-head-padding-y};
          --#{$prefix}stepper-mobile-head-padding-x: #{$stepper-mobile-head-padding-x};
          --#{$prefix}stepper-mobile-footer-height: #{$stepper-mobile-footer-height};
          --#{$prefix}stepper-back-btn-i-margin-right: #{$stepper-back-btn-i-margin-right};
          --#{$prefix}stepper-next-btn-i-margin-left: #{$stepper-next-btn-i-margin-left};
          --#{$prefix}stepper-mobile-progress-bar-height: #{$stepper-mobile-progress-bar-height};
          --#{$prefix}stepper-mobile-progress-height: #{$stepper-mobile-progress-height};
          --#{$prefix}stepper-mobile-progress-background-color: #{$stepper-mobile-progress-background-color};
          --#{$prefix}stepper-mobile-active-progress-bar-color: #{$stepper-mobile-active-progress-bar-color};
          --#{$prefix}stepper-mobile-footer-bg: #{$stepper-mobile-footer-bg};
          --#{$prefix}stepper-mobile-head-bg: #{$stepper-mobile-head-bg};
          --#{$prefix}stepper-mobile-invalid-icon-bg: #{$stepper-mobile-invalid-icon-bg};
          
        
    

SCSS variables

        
            
        // Steps
        $steps-transition: height 0.2s ease-in-out;

        $steps-step-after-left: 2.45rem;
        $steps-step-after-width: 1px;
        $steps-step-after-margin-top: 0.5rem;
        $steps-step-after-bg: rgba(var(--#{$prefix}emphasis-color-rgb), 0.1);

        $steps-content-padding-y: 1.5rem;

        $steps-head-vertical-padding-top: 1.5rem;
        $steps-head-vertical-padding-x: 1.5rem;

        $steps-head-icon-vertical-margin-right: 0.75rem;

        $steps-head-line-height: 1.3;
        $steps-head-hover-bgc: rgba(var(--#{$prefix}emphasis-color-rgb), 0.025);

        $steps-head-text-color: rgba(var(--#{$prefix}emphasis-color-rgb), 0.55);
        $steps-head-text-after-font-size: 0.8rem;
        
        $steps-head-icon-font-size: 0.875rem;
        $steps-head-icon-width: 1.938rem;
        $steps-head-icon-height: 1.938rem;
        $steps-head-icon-font-weight: 500;

        $steps-active-head-text-font-weight: 500;
        
        // Stepper
        $stepper-padding-x: 1rem;

        $stepper-step-height: 4.5rem;

        $stepper-step-head-padding-left: 1.5rem;
        $stepper-step-head-padding-right: 1.5rem;
        $stepper-step-head-height: 1px;
        $stepper-step-head-bg: rgba(var(--#{$prefix}emphasis-color-rgb), 0.1);
        $stepper-step-head-margin-right: 0.5rem;
        $stepper-step-head-margin-left: 0.5rem;

        $stepper-head-icon-margin-y: 1.5rem;
        $stepper-head-icon-margin-right: 0.5rem;

        $stepper-vertical-step-top: 3.25rem;
        $stepper-vertical-step-height: calc(100% - 2.45rem);
        $stepper-vertical-content-padding-left: 3.75rem;
        $stepper-vertical-content-transition: height 0.3s ease-in-out, margin-top 0.3s ease-in-out,
          margin-bottom 0.3s ease-in-out, padding-top 0.3s ease-in-out, padding-bottom 0.3s ease-in-out;
        $stepper-vertical-head-padding-bottom: 1.5rem;

        $stepper-mobile-step-margin-y: 1rem;
        $stepper-mobile-step-head-padding-x: 0.25rem;
        $stepper-mobile-head-icon-height: 0.5rem;
        $stepper-mobile-head-icon-width: 0.5rem;
        $stepper-mobile-content-top: 2.56rem;
        $stepper-mobile-active-head-icon-bg: var(--#{$prefix}primary);
        $stepper-mobile-completed-head-icon-bg: var(--#{$prefix}success);

        $stepper-head-icon-bg: var(--#{$prefix}surface-inverted-bg);
        $stepper-head-icon-color: var(--#{$prefix}surface-inverted-color);

        $stepper-completed-head-icon-bg: var(--#{$prefix}success-bg-subtle);
        $stepper-completed-head-icon-color: var(--#{$prefix}success-text-emphasis);

        $stepper-active-head-icon-bg: var(--#{$prefix}primary-bg-subtle);
        $stepper-active-head-icon-color: var(--#{$prefix}primary-text-emphasis);

        $stepper-invalid-head-icon-bg: var(--#{$prefix}danger-bg-subtle);
        $stepper-invalid-head-icon-color: var(--#{$prefix}danger-text-emphasis);

        $stepper-disabled-head-color: rgba(var(--#{$prefix}emphasis-color-rgb), 0.3);
        $stepper-disabled-head-icon-bg: $stepper-head-icon-bg;
        $stepper-disabled-head-icon-color: rgba(var(--#{$prefix}surface-inverted-color-rgb), 0.55);

        $stepper-mobile-head-padding-y: 0.5rem;
        $stepper-mobile-head-padding-x: 1rem;
        $stepper-mobile-head-bg: var(--#{$prefix}stepper-mobile-bg);
        $stepper-mobile-footer-height: 2.5rem;
        $stepper-mobile-footer-bg: $stepper-mobile-head-bg;
        $stepper-mobile-invalid-icon-bg: var(--#{$prefix}danger);
        $stepper-back-btn-i-margin-right: 0.5rem;
        $stepper-next-btn-i-margin-left: 0.5rem;

        $stepper-mobile-progress-bar-height: 0.3rem;
        $stepper-mobile-progress-height: 0.3rem;
        $stepper-mobile-progress-background-color: var(--#{$prefix}secondary-bg);
        $stepper-mobile-active-progress-bar-color: var(--#{$prefix}primary);

Stepper

Vue Stepper / Wizard component

Responsive stepper built with Bootstrap 5 and Vue 3. Form wizard, vertical stepper, multi step form validation, optional step, mobile stepper & more

Stepper is a component that displays content as a process with defined by user milestones. This is a great solution for a variety of registration forms, where you don't want to scare the user with lots of fields and questions.

In this documentation, you can find examples of form wizard, vertical stepper, horizontal stepper, multi step form, mobile stepper, validation & more.

Note: Read the API tab to find all available options and advanced customization


Basic example

Initialize stepper with MDBSteppercomponent

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <template>
              <MDBStepper>
                <MDBStepperStep active>
                  <MDBStepperHead icon="1">
                    Step 1
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                      incididunt ut labore et dolore magna aliqua
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead icon="2">
                    Step 2
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea
                      commodo consequat
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead icon="3">
                    Step 3
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
            </script>
          
        
    

Change steps using external elements

To go to the next or previous step, you can use the nextStep and previousStep methods. You can also choose a specific step using the changeStep method by entering the step index

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <template>
              <div class="w-100">
                <div class="mb-3">
                  <MDBBtn
                    id="prev-step"
                    color="primary"
                    @click="btnStepper?.prevStep()"
                  >
                    prev
                  </MDBBtn>
                  <MDBBtn
                    id="step-1"
                    color="primary"
                    @click="btnStepper?.changeStep(1)"
                  >
                    step1
                  </MDBBtn>
                  <MDBBtn
                    id="step-2"
                    color="primary"
                    @click="btnStepper?.changeStep(2)"
                  >
                    step2
                  </MDBBtn>
                  <MDBBtn
                    id="step-3"
                    color="primary"
                    @click="btnStepper?.changeStep(3)"
                  >
                    step3
                  </MDBBtn>
                  <MDBBtn
                    id="next-step"
                    color="primary"
                    @click="btnStepper?.nextStep()"
                  >
                    next
                  </MDBBtn>
                </div>
                <div>
                  <MDBStepper ref="btnStepper">
                    <MDBStepperStep active>
                      <MDBStepperHead icon="1">
                        Step 1
                      </MDBStepperHead>
                      <MDBStepperContent>
                        <span>
                          Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                          incididunt ut labore et dolore magna aliqua
                        </span>
                      </MDBStepperContent>
                    </MDBStepperStep>
                    <MDBStepperStep>
                      <MDBStepperHead icon="2">
                        Step 2
                      </MDBStepperHead>
                      <MDBStepperContent>
                        <span>
                          Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                          ex ea commodo consequat
                        </span>
                      </MDBStepperContent>
                    </MDBStepperStep>
                    <MDBStepperStep>
                      <MDBStepperHead icon="3">
                        Step 3
                      </MDBStepperHead>
                      <MDBStepperContent>
                        <span>
                          Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                          fugiat nulla pariatur
                        </span>
                      </MDBStepperContent>
                    </MDBStepperStep>
                  </MDBStepper>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent,
                  MDBBtn
                },
                setup(){
                  const btnStepper = ref(null);

                  return {
                    btnStepper,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const btnStepper = ref<InstanceType<typeof MDBStepper> | null>(null);
            </script>
          
        
    

Linear stepper

If you want to use basic validation before proceeding to the next step you can set linear property

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <template>
              <MDBStepper linear>
                <MDBStepperForm>
                  <MDBStepperStep active>
                    <MDBStepperHead icon="1">
                      Step 1
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput
                        label="Step 1"
                        v-model="stepperInput1"
                        invalidFeedback="Invalid"
                        required
                      />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="2">
                      Step 2
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput
                        label="Step 2"
                        v-model="stepperInput2"
                        invalidFeedback="Invalid"
                        required
                      />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="3">
                      Step 3
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput
                        label="Step 3"
                        v-model="stepperInput3"
                        invalidFeedback="Invalid"
                        required
                      />
                      <MDBBtn color="primary" type="submit">Submit</MDBBtn>
                    </MDBStepperContent>
                  </MDBStepperStep>
                </MDBStepperForm>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent,
                  MDBStepperForm,
                  MDBInput,
                  MDBBtn
                },
                setup(){
                  const stepperInput1 = ref("");
                  const stepperInput2 = ref("");
                  const stepperInput3 = ref("");
                  return {
                    stepperInput1,
                    stepperInput2,
                    stepperInput3
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
                  
              const stepperInput1 = ref("");
              const stepperInput2 = ref("");
              const stepperInput3 = ref("");
            </script>
          
        
    

No editable stepper

You can set noEditable property to prevent you from editing the completed step again

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <template>
              <MDBStepper noEditable>
                <MDBStepperForm>
                  <MDBStepperStep active>
                    <MDBStepperHead icon="1">
                      Step 1
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput label="Step 1" v-model="stepperInput4" />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="2">
                      Step 2
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput label="Step 2" v-model="stepperInput5" />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="3">
                      Step 3
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput label="Step 3" v-model="stepperInput6" />
                    </MDBStepperContent>
                  </MDBStepperStep>
                </MDBStepperForm>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent,
                  MDBStepperForm,
                  MDBInput
                },
                setup(){
                  const stepperInput4 = ref("");
                  const stepperInput5 = ref("");
                  const stepperInput6 = ref("");
                  return {
                    stepperInput4,
                    stepperInput5,
                    stepperInput6
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              
              const stepperInput4 = ref("");
              const stepperInput5 = ref("");
              const stepperInput6 = ref("");
            </script>
          
        
    

Vertical stepper

Set vertical property to use the vertical view

  • 1 step1
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 2 step2
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 3 step3
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
        
            
            <template>
              <MDBStepper vertical>
                <MDBStepperStep active>
                  <MDBStepperHead icon="1">
                    step1
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet enim. Etiam ullamcorper.
                      Suspendisse a pellentesque dui, non felis. Maecenas malesuada
                      elit lectus felis, malesuada ultricies.
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead icon="2">
                    step2
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet enim. Etiam ullamcorper.
                      Suspendisse a pellentesque dui, non felis. Maecenas malesuada
                      elit lectus felis, malesuada ultricies.
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead icon="3">
                    step3
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet enim. Etiam ullamcorper.
                      Suspendisse a pellentesque dui, non felis. Maecenas malesuada
                      elit lectus felis, malesuada ultricies.
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
            </script>
          
        
    

Mobile stepper

Set mobile property to use mobile view

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <template>
              <MDBStepper mobile>
                <MDBStepperStep active>
                  <MDBStepperHead icon="1">
                    step1
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                      incididunt ut labore et dolore magna aliqua
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead icon="2">
                    step2
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea
                      commodo consequat
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead icon="3">
                    step3
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
            </script>
          
        
    

Mobile stepper progress bar

If the stepper contains more than 4 steps, the progress bar will be displayed by default instead of dots. You can edit the step limit with the mobile mobileProgress properties

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <template>
              <MDBStepper mobile mobileProgress>
                <MDBStepperStep active>
                  <MDBStepperHead icon="1">
                    step1
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
                      incididunt ut labore et dolore magna aliqua
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="2">
                    step2
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea
                      commodo consequat
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="3">
                    step3
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="4">
                    step4
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="5">
                    step5
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="6">
                    step6
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="7">
                    step7
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="8">
                    step8
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="9">
                    step9
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="10">
                    step10
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="11">
                    step11
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep active>
                  <MDBStepperHead icon="12">
                    step12
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat
                      nulla pariatur
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
            </script>
          
        
    

Optional step

You can mark a step as optional by adding optional to it

  • 1 step1
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 2 step2
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 3 step3
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
        
            
            <template>
              <MDBStepper>
                <MDBStepperStep active>
                  <MDBStepperHead icon="1">
                    step1
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet enim. Etiam ullamcorper.
                      Suspendisse a pellentesque dui, non felis. Maecenas malesuada
                      elit lectus felis, malesuada ultricies.
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep optional>
                  <MDBStepperHead icon="2">
                    step2
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet enim. Etiam ullamcorper.
                      Suspendisse a pellentesque dui, non felis. Maecenas malesuada
                      elit lectus felis, malesuada ultricies.
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead icon="3">
                    step3
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <span>
                      Lorem ipsum dolor sit amet enim. Etiam ullamcorper.
                      Suspendisse a pellentesque dui, non felis. Maecenas malesuada
                      elit lectus felis, malesuada ultricies.
                    </span>
                  </MDBStepperContent>
                </MDBStepperStep>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent } from "mdb-vue-ui-kit";
            </script>
          
        
    

Custom icons

if you want to use an icon instead of a step number you can do it by placing it inside #icon slot

  • step1
    invalid
  • step2
    invalid
  • step3
    invalid
        
            
            <template>
              <MDBStepper>
                <MDBStepperForm>
                  <MDBStepperStep active>
                    <MDBStepperHead>
                      <template #icon>
                        <MDBIcon icon="user" />
                      </template>
                      Step 1
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput label="Step 1" v-model="stepperInput7" />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead>
                      <template #icon>
                        <MDBIcon icon="envelope" />
                      </template>
                      Step 2
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput label="Step 2" v-model="stepperInput8" />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead>
                      <template #icon>
                        <MDBSpinner size="sm"></MDBSpinner>
                      </template>
                      Step 3
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput label="Step 3" v-model="stepperInput9" />
                    </MDBStepperContent>
                  </MDBStepperStep>
                </MDBStepperForm>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput, MDBIcon, MDBSpinner } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent,
                  MDBStepperForm,
                  MDBInput,
                  MDBIcon,
                  MDBSpinner
                },
                setup(){
                  const stepperInput7 = ref("");
                  const stepperInput8 = ref("");
                  const stepperInput9 = ref("");
                  return {
                    stepperInput7,
                    stepperInput8,
                    stepperInput9
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput, MDBIcon, MDBSpinner } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const stepperInput7 = ref("");
              const stepperInput8 = ref("");
              const stepperInput9 = ref("");
            </script>
          
        
    

Form wizard

An example of so-called "Form wizard" with multiple inputs on each step.

  • 1 step1
    invalid
    invalid
  • 2 step2
    invalid
    invalid
    invalid
    invalid
  • 3 step3
        
            
            <template>
              <div>
                <MDBStepper linear ref="formWizardRef">
                  <MDBStepperForm>
                    <MDBStepperStep active>
                      <MDBStepperHead icon="1">
                        Step 1
                      </MDBStepperHead>
                      <MDBStepperContent>
                        <MDBInput
                          label="First Name (required)"
                          v-model="stepperInput10"
                          invalidFeedback="Invalid"
                          required
                          wrapperClass="mb-4"
                        />
                        <MDBInput
                          label="Last Name (required)"
                          v-model="stepperInput11"
                          invalidFeedback="Invalid"
                          required
                          wrapperClass="mb-4"
                        />
                        <MDBInput
                          label="Nickname (optional)"
                          v-model="stepperInput12"
                          wrapperClass="mb-4"
                        />
                      </MDBStepperContent>
                    </MDBStepperStep>
                    <MDBStepperStep>
                      <MDBStepperHead icon="2">
                        Step 2
                      </MDBStepperHead>
                      <MDBStepperContent>
                        <MDBInput
                          label="Company Name (required)"
                          v-model="stepperInput13"
                          invalidFeedback="Invalid"
                          required
                          wrapperClass="mb-4"
                        />
                        <MDBInput
                          label="Address (required)"
                          v-model="stepperInput14"
                          invalidFeedback="Invalid"
                          required
                          wrapperClass="mb-4"
                        />
                        <MDBInput
                          label="Email (required)"
                          type="email"
                          v-model="stepperInput15"
                          invalidFeedback="Invalid"
                          required
                          wrapperClass="mb-4"
                        />
                        <MDBInput
                          label="Phone (optional)"
                          type="number"
                          v-model="stepperInput16"
                          wrapperClass="mb-4"
                        />
                      </MDBStepperContent>
                    </MDBStepperStep>
                    <MDBStepperStep>
                      <MDBStepperHead icon="3">
                        Step 3
                      </MDBStepperHead>
                      <MDBStepperContent>
                        <MDBTextarea
                          label="Additional information"
                          rows="4"
                          v-model="textarea1"
                          wrapperClass="mb-4"
                        />
                        <MDBCheckbox
                          label="Create an account?"
                          v-model="checkbox1"
                          wrapperClass="d-flex justify-content-center mb-4"
                        />
                        <MDBBtn color="success" block type="submit">
                          Place Order
                        </MDBBtn>
                      </MDBStepperContent>
                    </MDBStepperStep>
                  </MDBStepperForm>
                </MDBStepper>
                <div class="d-flex justify-content-center px-3">
                  <MDBBtn
                    color="primary"
                    class="w-100 me-2"
                    @click="formWizardRef?.prevStep()"
                  >
                    Previous step
                  </MDBBtn>
                  <MDBBtn
                    color="primary"
                    class="w-100"
                    @click="formWizardRef?.nextStep()"
                  >
                    Next step
                  </MDBBtn>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput, MDBTextarea, MDBCheckbox, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent,
                  MDBStepperForm,
                  MDBInput,
                  MDBTextarea,
                  MDBCheckbox, MDBBtn
                },
                setup(){
                  const formWizardRef = ref(null);

                  const stepperInput10 = ref("");
                  const stepperInput11 = ref("");
                  const stepperInput12 = ref("");
                  const stepperInput13 = ref("");
                  const stepperInput14 = ref("");
                  const stepperInput15 = ref("");
                  const stepperInput16 = ref("");
                  const textarea1 = ref("");
                  const checkbox1 = ref(true);
                  return {
                    formWizardRef,
                    stepperInput10,
                    stepperInput11,
                    stepperInput12,
                    stepperInput13,
                    stepperInput14,
                    stepperInput15,
                    stepperInput16,
                    textarea1,
                    checkbox1
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput, MDBTextarea, MDBCheckbox, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const formWizardRef = ref<InstanceType<typeof MDBStepper> | null>(null);

              const stepperInput10 = ref("");
              const stepperInput11 = ref("");
              const stepperInput12 = ref("");
              const stepperInput13 = ref("");
              const stepperInput14 = ref("");
              const stepperInput15 = ref("");
              const stepperInput16 = ref("");
              const textarea1 = ref("");
              const checkbox1 = ref(true);
            </script>
          
        
    

Toggle to vertical or mobile on smaller screens

If you want to change the view from horizontal to vertical or mobile with smaller screens you can use the verticalBreakpoint and mobileBeakpoint properties specifying the number of pixels at which the stepper should change to vertical or mobile. You can resize the browser window to test it.

  • step1
    invalid
  • step2
    invalid
  • step3
    invalid
        
            
            <template>
              <MDBStepper :verticalBreakpoint="768" :mobileBreakpoint="400">
                <MDBStepperStep active>
                  <MDBStepperHead>
                    <template #icon>
                      <MDBIcon icon="user" />
                    </template>
                    Step 1
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <MDBInput label="Step 1" v-model="stepperInput17" />
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead>
                    <template #icon>
                      <MDBIcon icon="envelope" />
                    </template>
                    Step 2
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <MDBInput label="Step 2" v-model="stepperInput18" />
                  </MDBStepperContent>
                </MDBStepperStep>
                <MDBStepperStep>
                  <MDBStepperHead>
                    <template #icon>
                      <MDBSpinner size="sm"></MDBSpinner>
                    </template>
                    Step 3
                  </MDBStepperHead>
                  <MDBStepperContent>
                    <MDBInput label="Step 3" v-model="stepperInput19" />
                  </MDBStepperContent>
                </MDBStepperStep>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBInput, MDBIcon, MDBSpinner } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent,
                  MDBInput,
                  MDBIcon,
                  MDBSpinner
                },
                setup(){
                  const stepperInput17 = ref("");
                  const stepperInput18 = ref("");
                  const stepperInput19 = ref("");
                  return {
                    stepperInput17,
                    stepperInput18,
                    stepperInput19
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBInput, MDBIcon, MDBSpinner } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const stepperInput17 = ref("");
              const stepperInput18 = ref("");
              const stepperInput19 = ref("");
            </script>
          
        
    

Events

Stepper emits events after successful step validation, after failed step validation, and before changing to another step. Check the browser console and try to change the step to see the result.

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <template>
              <MDBStepper
                linear
                @onInvalid="onInvalid"
                @onValid="onValid"
                @onChangeStep="onChangeStep"
              >
                <MDBStepperForm>
                  <MDBStepperStep active>
                    <MDBStepperHead icon="1">
                      Step 1
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput
                        label="Step 1"
                        v-model="stepperInput20"
                        invalidFeedback="Invalid"
                        required
                      />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="2">
                      Step 2
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput
                        label="Step 2"
                        v-model="stepperInput21"
                        invalidFeedback="Invalid"
                        required
                      />
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="3">
                      Step 3
                    </MDBStepperHead>
                    <MDBStepperContent>
                      <MDBInput
                        label="Step 3"
                        v-model="stepperInput22"
                        invalidFeedback="Invalid"
                        required
                      />
                    </MDBStepperContent>
                  </MDBStepperStep>
                </MDBStepperForm>
              </MDBStepper>
            </template>
          
        
    
        
            
            <script>
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput } from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBStepper,
                  MDBStepperStep,
                  MDBStepperHead,
                  MDBStepperContent,
                  MDBStepperForm,
                  MDBInput
                },
                setup(){
                  const stepperInput20 = ref("");
                  const stepperInput21 = ref("");
                  const stepperInput22 = ref("");
                  const onInvalid = e => {
                    console.log(e);
                  };
                  const onValid = e => {
                    console.log(e);
                  };
                  const onChangeStep = e => {
                    console.log(e);
                  };
                  return {
                    stepperInput20,
                    stepperInput21,
                    stepperInput22,
                    onInvalid,
                    onValid,
                    onChangeStep
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBStepper, MDBStepperStep, MDBStepperHead, MDBStepperContent, MDBStepperForm, MDBInput } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const stepperInput20 = ref("");
              const stepperInput21 = ref("");
              const stepperInput22 = ref("");
              const onInvalid = (e: HTMLElement) => {
                console.log(e);
              };
              const onValid = (e: HTMLElement) => {
                console.log(e);
              };
              const onChangeStep = (e: HTMLElement) => {
                console.log(e);
              };
            </script>
          
        
    

If you want to support our friends from TW Elements you can also check out the Tailwind stepper documentation.


TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

Stepper - API


Import

        
            
          <script>
            import {
              MDBStepper,
              MDBStepperStep,
              MDBStepperHead,
              MDBStepperContent,
              MDBStepperForm
            } from 'mdb-vue-ui-kit';
          </script>
        
        
    

Properties

MDBStepper

Name Type Default Description
tag String 'ul' Defines tag of the MDBStepper element
activeStepIndex Number 1 Set initial active step
animation Boolean true Adds animation after step change
linear Boolean false Set true for linear stepper
vertical Boolean false Set true for vertical stepper
mobile Boolean false Set true for mobile stepper
mobileProgress Boolean false Set true to indicate progress of the stepper
noEditable Boolean false Set true to block editing of the completed step
verticalBreakpoint Number Set the resolution below which the stepper will switch to vertical mode
mobileBreakpoint Number Set the resolution below which the stepper will switch to mobile mode
disableStepperHeadClick Boolean false Set true to block the possibility of changing a step by clicking on another step
nextBtn String NEXT Set custom text for NEXT button
backBtn String BACK Set custom text for BACK button
stepTxt String step Set custom step value in the mobile stepper head
stepOfTxt String of Set custom of value in the mobile stepper head

MDBStepperStep

Name Type Default Description
dynamic Boolean false Recalculates the stepper height on content change
tag String 'li' Defines tag of the MDBStepperStep element
optional Boolean false Sets stepper step element optional

MDBStepperHead

Name Type Default Description
tag String 'div' Defines tag of the MDBStepperHead element

MDBStepperContent

Name Type Default Description
tag String 'div' Defines tag of the MDBStepperContent element

MDBStepperForm

Name Type Default Description
tag String 'div' Defines tag of the MDBStepperForm element

Methods

MDBStepper

Name Description Example
changeStep Switch to the step given as the parameter stepper.changeStep(index)
nextStep Switch to the next step stepper.nextStep()
prevStep Switch to the previous step stepper.prevStep()

MDBStepperStep

Name Description Example
setHeight Recalculates the height of the stepper step stepperStep.setHeight()
        
            
          <template>
            <div class="w-100">
              <div class="mb-3">
                <MDBBtn id="prev-step" color="primary" @click="stepperRef?.prevStep()">
                  prev
                </MDBBtn>
                <MDBBtn id="next-step" color="primary" @click="stepperRef?.nextStep()">
                  next
                </MDBBtn>
              </div>
              <div>
                <MDBStepper ref="stepperRef">
                  <MDBStepperStep active>
                    <MDBStepperHead icon="1"> Step 1 </MDBStepperHead>
                    <MDBStepperContent>
                      <span>
                        Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do
                        eiusmod tempor incididunt ut labore et dolore magna aliqua
                      </span>
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="2"> Step 2 </MDBStepperHead>
                    <MDBStepperContent>
                      <span>
                        Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris
                        nisi ut aliquip ex ea commodo consequat
                      </span>
                    </MDBStepperContent>
                  </MDBStepperStep>
                  <MDBStepperStep>
                    <MDBStepperHead icon="3"> Step 3 </MDBStepperHead>
                    <MDBStepperContent>
                      <span>
                        Duis aute irure dolor in reprehenderit in voluptate velit esse
                        cillum dolore eu fugiat nulla pariatur
                      </span>
                    </MDBStepperContent>
                  </MDBStepperStep>
                </MDBStepper>
              </div>
            </div>
          </template>
        
        
    
        
            
        <script>
          import {
            MDBStepper,
            MDBStepperStep,
            MDBStepperHead,
            MDBStepperContent,
            MDBBtn,
          } from "mdb-vue-ui-kit";
          import { ref } from "vue";

          export default {
            components: {
              MDBStepper,
              MDBStepperStep,
              MDBStepperHead,
              MDBStepperContent,
              MDBBtn,
            },
            setup() {
              const stepperRef = ref(null);
          
              return {
                stepperRef,
              };
            },
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import {
            MDBStepper,
            MDBStepperStep,
            MDBStepperHead,
            MDBStepperContent,
            MDBBtn,
          } from "mdb-vue-ui-kit";
          import { ref } from "vue";

          const stepperRef = ref<InstanceType<typeof MDBStepper> | null>(null);
        </script>
        
        
    

Events

Name Description
@onChangeStep Event emitted before the step change
@onChangedStep This event is emitted after the active step change is taking place. Information about the current and previous steps can be accessed through the following properties of the emitted event: e.currentStep and e.prevStep.
@onValid Event emitted after successful step validation
@onInvalid Event emitted after unsuccessful step validation
        
            
          <template>
            <MDBStepper @onChangeStep="doSomething" >...</MDBStepper>
          </template>
        
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, stepper now use local CSS variables on .stepper for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

        
            
          // .steps
          --#{$prefix}steps-transition: #{$steps-transition};

          // .steps-step
          --#{$prefix}steps-step-after-left: #{$steps-step-after-left};
          --#{$prefix}steps-step-after-width: #{$steps-step-after-width};
          --#{$prefix}steps-step-after-margin-top: #{$steps-step-after-margin-top};
          --#{$prefix}steps-step-after-bg: #{$steps-step-after-bg};

          // .steps-content
          --#{$prefix}steps-content-padding-y: #{$steps-content-padding-y};

          // .steps-head-vertical
          --#{$prefix}steps-head-vertical-padding-top: #{$steps-head-vertical-padding-top};
          --#{$prefix}steps-head-vertical-padding-x: #{$steps-head-vertical-padding-x};

          // .steps-head-icon-vertical
          --#{$prefix}steps-head-icon-vertical-margin-right: #{$steps-head-icon-vertical-margin-right};

          // .steps-head
          --#{$prefix}steps-head-line-height: #{$steps-head-line-height};
          --#{$prefix}steps-head-hover-bgc: #{$steps-head-hover-bgc};

          // .steps-head-text
          --#{$prefix}steps-head-text-color: #{$steps-head-text-color};
          --#{$prefix}steps-head-text-after-font-size: #{$steps-head-text-after-font-size};

          // .steps-head-icon
          --#{$prefix}steps-head-icon-font-size: #{$steps-head-icon-font-size};
          --#{$prefix}steps-head-icon-width: #{$steps-head-icon-width};
          --#{$prefix}steps-head-icon-height: #{$steps-head-icon-height};
          --#{$prefix}steps-head-icon-font-weight: #{$steps-head-icon-font-weight};

          // .steps-active-head-text
          --#{$prefix}steps-active-head-text-font-weight: #{$steps-active-head-text-font-weight};
          
          // .stepper
          --#{$prefix}stepper-padding-x: #{$stepper-padding-x};
          --#{$prefix}stepper-step-height: #{$stepper-step-height};
          --#{$prefix}stepper-step-head-padding-left: #{$stepper-step-head-padding-left};
          --#{$prefix}stepper-step-head-padding-right: #{$stepper-step-head-padding-right};
          --#{$prefix}stepper-step-head-height: #{$stepper-step-head-height};
          --#{$prefix}stepper-step-head-bg: #{$stepper-step-head-bg};
          --#{$prefix}stepper-step-head-margin-right: #{$stepper-step-head-margin-right};
          --#{$prefix}stepper-step-head-margin-left: #{$stepper-step-head-margin-left};
          --#{$prefix}stepper-head-icon-margin-y: #{$stepper-head-icon-margin-y};
          --#{$prefix}stepper-head-icon-margin-right: #{$stepper-head-icon-margin-right};
          --#{$prefix}stepper-vertical-step-top: #{$stepper-vertical-step-top};
          --#{$prefix}stepper-vertical-step-height: #{$stepper-vertical-step-height};
          --#{$prefix}stepper-vertical-content-padding-left: #{$stepper-vertical-content-padding-left};
          --#{$prefix}stepper-vertical-content-transition: #{$stepper-vertical-content-transition};
          --#{$prefix}stepper-vertical-head-padding-bottom: #{$stepper-vertical-head-padding-bottom};
          --#{$prefix}stepper-mobile-step-margin-y: #{$stepper-mobile-step-margin-y};
          --#{$prefix}stepper-mobile-step-head-padding-x: #{$stepper-mobile-step-head-padding-x};
          --#{$prefix}stepper-mobile-head-icon-height: #{$stepper-mobile-head-icon-height};
          --#{$prefix}stepper-mobile-head-icon-width: #{$stepper-mobile-head-icon-width};
          --#{$prefix}stepper-mobile-content-top: #{$stepper-mobile-content-top};
          --#{$prefix}stepper-mobile-active-head-icon-bg: #{$stepper-mobile-active-head-icon-bg};
          --#{$prefix}stepper-mobile-completed-head-icon-bg: #{$stepper-mobile-completed-head-icon-bg};
          --#{$prefix}stepper-head-icon-bg: #{$stepper-head-icon-bg};
          --#{$prefix}stepper-head-icon-color: #{$stepper-head-icon-color};
          --#{$prefix}stepper-completed-head-icon-bg: #{$stepper-completed-head-icon-bg};
          --#{$prefix}stepper-completed-head-icon-color: #{$stepper-completed-head-icon-color};
          --#{$prefix}stepper-active-head-icon-bg: #{$stepper-active-head-icon-bg};
          --#{$prefix}stepper-active-head-icon-color: #{$stepper-active-head-icon-color};
          --#{$prefix}stepper-invalid-head-icon-bg: #{$stepper-invalid-head-icon-bg};
          --#{$prefix}stepper-invalid-head-icon-color: #{$stepper-invalid-head-icon-color};
          --#{$prefix}stepper-disabled-head-color: #{$stepper-disabled-head-color};
          --#{$prefix}stepper-disabled-head-icon-bg: #{$stepper-disabled-head-icon-bg};
          --#{$prefix}stepper-disabled-head-icon-color: #{$stepper-disabled-head-icon-color};
          --#{$prefix}stepper-mobile-head-padding-y: #{$stepper-mobile-head-padding-y};
          --#{$prefix}stepper-mobile-head-padding-x: #{$stepper-mobile-head-padding-x};
          --#{$prefix}stepper-mobile-footer-height: #{$stepper-mobile-footer-height};
          --#{$prefix}stepper-back-btn-i-margin-right: #{$stepper-back-btn-i-margin-right};
          --#{$prefix}stepper-next-btn-i-margin-left: #{$stepper-next-btn-i-margin-left};
          --#{$prefix}stepper-mobile-progress-bar-height: #{$stepper-mobile-progress-bar-height};
          --#{$prefix}stepper-mobile-progress-height: #{$stepper-mobile-progress-height};
          --#{$prefix}stepper-mobile-progress-background-color: #{$stepper-mobile-progress-background-color};
          --#{$prefix}stepper-mobile-active-progress-bar-color: #{$stepper-mobile-active-progress-bar-color};
          --#{$prefix}stepper-mobile-footer-bg: #{$stepper-mobile-footer-bg};
          --#{$prefix}stepper-mobile-head-bg: #{$stepper-mobile-head-bg};
          --#{$prefix}stepper-mobile-invalid-icon-bg: #{$stepper-mobile-invalid-icon-bg};
          
        
    

SCSS variables

        
            
        // Steps
        $steps-transition: height 0.2s ease-in-out;

        $steps-step-after-left: 2.45rem;
        $steps-step-after-width: 1px;
        $steps-step-after-margin-top: 0.5rem;
        $steps-step-after-bg: rgba(var(--#{$prefix}emphasis-color-rgb), 0.1);

        $steps-content-padding-y: 1.5rem;

        $steps-head-vertical-padding-top: 1.5rem;
        $steps-head-vertical-padding-x: 1.5rem;

        $steps-head-icon-vertical-margin-right: 0.75rem;

        $steps-head-line-height: 1.3;
        $steps-head-hover-bgc: rgba(var(--#{$prefix}emphasis-color-rgb), 0.025);

        $steps-head-text-color: rgba(var(--#{$prefix}emphasis-color-rgb), 0.55);
        $steps-head-text-after-font-size: 0.8rem;
        
        $steps-head-icon-font-size: 0.875rem;
        $steps-head-icon-width: 1.938rem;
        $steps-head-icon-height: 1.938rem;
        $steps-head-icon-font-weight: 500;

        $steps-active-head-text-font-weight: 500;
        
        // Stepper
        $stepper-padding-x: 1rem;

        $stepper-step-height: 4.5rem;

        $stepper-step-head-padding-left: 1.5rem;
        $stepper-step-head-padding-right: 1.5rem;
        $stepper-step-head-height: 1px;
        $stepper-step-head-bg: rgba(var(--#{$prefix}emphasis-color-rgb), 0.1);
        $stepper-step-head-margin-right: 0.5rem;
        $stepper-step-head-margin-left: 0.5rem;

        $stepper-head-icon-margin-y: 1.5rem;
        $stepper-head-icon-margin-right: 0.5rem;

        $stepper-vertical-step-top: 3.25rem;
        $stepper-vertical-step-height: calc(100% - 2.45rem);
        $stepper-vertical-content-padding-left: 3.75rem;
        $stepper-vertical-content-transition: height 0.3s ease-in-out, margin-top 0.3s ease-in-out,
          margin-bottom 0.3s ease-in-out, padding-top 0.3s ease-in-out, padding-bottom 0.3s ease-in-out;
        $stepper-vertical-head-padding-bottom: 1.5rem;

        $stepper-mobile-step-margin-y: 1rem;
        $stepper-mobile-step-head-padding-x: 0.25rem;
        $stepper-mobile-head-icon-height: 0.5rem;
        $stepper-mobile-head-icon-width: 0.5rem;
        $stepper-mobile-content-top: 2.56rem;
        $stepper-mobile-active-head-icon-bg: var(--#{$prefix}primary);
        $stepper-mobile-completed-head-icon-bg: var(--#{$prefix}success);

        $stepper-head-icon-bg: var(--#{$prefix}surface-inverted-bg);
        $stepper-head-icon-color: var(--#{$prefix}surface-inverted-color);

        $stepper-completed-head-icon-bg: var(--#{$prefix}success-bg-subtle);
        $stepper-completed-head-icon-color: var(--#{$prefix}success-text-emphasis);

        $stepper-active-head-icon-bg: var(--#{$prefix}primary-bg-subtle);
        $stepper-active-head-icon-color: var(--#{$prefix}primary-text-emphasis);

        $stepper-invalid-head-icon-bg: var(--#{$prefix}danger-bg-subtle);
        $stepper-invalid-head-icon-color: var(--#{$prefix}danger-text-emphasis);

        $stepper-disabled-head-color: rgba(var(--#{$prefix}emphasis-color-rgb), 0.3);
        $stepper-disabled-head-icon-bg: $stepper-head-icon-bg;
        $stepper-disabled-head-icon-color: rgba(var(--#{$prefix}surface-inverted-color-rgb), 0.55);

        $stepper-mobile-head-padding-y: 0.5rem;
        $stepper-mobile-head-padding-x: 1rem;
        $stepper-mobile-head-bg: var(--#{$prefix}stepper-mobile-bg);
        $stepper-mobile-footer-height: 2.5rem;
        $stepper-mobile-footer-bg: $stepper-mobile-head-bg;
        $stepper-mobile-invalid-icon-bg: var(--#{$prefix}danger);
        $stepper-back-btn-i-margin-right: 0.5rem;
        $stepper-next-btn-i-margin-left: 0.5rem;

        $stepper-mobile-progress-bar-height: 0.3rem;
        $stepper-mobile-progress-height: 0.3rem;
        $stepper-mobile-progress-background-color: var(--#{$prefix}secondary-bg);
        $stepper-mobile-active-progress-bar-color: var(--#{$prefix}primary);

Stepper

React Bootstrap 5 Stepper / Wizard component

Responsive stepper built with Bootstrap 5. Form wizard, vertical stepper, multi step form validation, optional step, mobile stepper & more.

Stepper is a component that displays content as a process with defined by user milestones. This is a great solution for a variety of registration forms, where you don't want to scare the user with lots of fields and questions.

In this documentation, you can find examples of form wizard, vertical stepper, horizontal stepper, multi step form, mobile stepper, validation & more.

Note: Read the API tab to find all available options and advanced customization


Basic example

You can automatically initialize the stepper component using MDBStepper.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            import React from 'react';
            import { 
              MDBStepper, 
              MDBStepperStep,
            } from 'mdb-react-ui-kit';
            
            export default function App() {
              return (
                <MDBStepper>
                  <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua
                  </MDBStepperStep>

                  <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                    consequat
                  </MDBStepperStep>

                  <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                  </MDBStepperStep>
                </MDBStepper>
              );
            }
          
        
    

Change steps using external elements

To go to the next or previous step, you can use the reference to the buttons.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
          import React, { useRef } from 'react';
          import { 
            MDBStepper, 
            MDBStepperStep,
            MDBBtn
          } from 'mdb-react-ui-kit';
          
          export default function App() {
            const prevRef = useRef(null);
            const nextRef = useRef(null);

            return (
              <div className='w-100'>
                <div className='mb-3'>
                  <MDBBtn ref={prevRef}>PREV</MDBBtn>
                  <MDBBtn ref={nextRef}>NEXT</MDBBtn>
                </div>
                <div>
                  <MDBStepper disableHeadSteps externalNext={nextRef} externalPrev={prevRef}>
                    <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                      Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore
                      et dolore magna aliqua
                    </MDBStepperStep>
  
                    <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                      Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                      consequat
                    </MDBStepperStep>
  
                    <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                      Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla
                      pariatur
                    </MDBStepperStep>
                  </MDBStepper>
                </div>
              </div>
            );
          }
        
        
    

Linear stepper

If you want to use basic validation before proceeding to the next step you can set linear property.

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
          import React from 'react';
          import { 
            MDBStepper, 
            MDBStepperStep,
            MDBStepperForm,
            MDBInput,
            MDBValidationItem,
            MDBBtn
          } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBStepper
                linear
              >
                <MDBStepperForm>
                  <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                    <MDBValidationItem invalid feedback='invalid'>
                      <MDBInput label='step 1' required />
                    </MDBValidationItem>
                  </MDBStepperStep>

                  <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                    <MDBValidationItem invalid feedback='invalid'>
                      <MDBInput label='step 2' required />
                    </MDBValidationItem>
                  </MDBStepperStep>

                  <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                    <MDBValidationItem invalid feedback='invalid'>
                      <MDBInput wrapperClass='mb-4' label='step 3' required />
                      <MDBBtn type='submit'>submit</MDBBtn>
                    </MDBValidationItem>
                  </MDBStepperStep>
                </MDBStepperForm>
              </MDBStepper>
            );
          }
        
        
    

No editable stepper

You can set noEditable property to prevent you from editing the completed step again.

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
          import React, { useState } from 'react';
          import { 
            MDBStepper, 
            MDBStepperStep,
            MDBInput,
          } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBStepper noEditable>
                <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                  <MDBInput label='step 1' />
                </MDBStepperStep>
  
                <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                  <MDBInput label='step 2' />
                </MDBStepperStep>
  
                <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                  <MDBInput label='step 3' />
                </MDBStepperStep>
              </MDBStepper>
            );
          }
        
        
    

Vertical stepper

Set type='vertical' to use the vertical view.

  • 1 step1
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 2 step2
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultriciesUt enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
        
            
          import React from 'react';
          import { 
            MDBStepper, 
            MDBStepperStep,
          } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBStepper type='vertical'>
                <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                  Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et.
                  dolore magna aliqua
                </MDBStepperStep>
  
                <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo.
                  consequat
                </MDBStepperStep>
  
                <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
                </MDBStepperStep>
              </MDBStepper>
            );
          }
        
        
    

Mobile stepper

Set type='mobile' to use mobile view.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
          import React from 'react';
          import { 
            MDBStepper, 
            MDBStepperStep,
          } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBStepper type='mobile'>
                <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                  Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et
                  dolore magna aliqua
                </MDBStepperStep>
  
                <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                  consequat
                </MDBStepperStep>
  
                <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
              </MDBStepper>
            );
          }
        
        
    

Mobile stepper progress bar

if the stepper contains more than 4 steps, the progress bar will be displayed by default instead of dots. You can edit the step limit with the mobileProgress property.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
          import React from 'react';
          import { 
            MDBStepper, 
            MDBStepperStep,
          } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBStepper mobile mobileProgress>
                <MDBStepperStep itemId={1} icon='1' text='step1'>
                  Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et
                  dolore magna aliqua
                </MDBStepperStep>
  
                <MDBStepperStep itemId={2} icon='2' text='step2'>
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
                  consequat
                </MDBStepperStep>
  
                <MDBStepperStep itemId={3} icon='3' text='step3'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
  
                <MDBStepperStep itemId={4} icon='4' text='step4'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
  
                <MDBStepperStep itemId={5} icon='5' text='step5'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
  
                <MDBStepperStep itemId={6} icon='6' text='step6'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
  
                <MDBStepperStep itemId={7} icon='7' text='step7'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
  
                <MDBStepperStep itemId={8} icon='8' text='step8'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
                <MDBStepperStep itemId={9} icon='9' text='step9'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
                <MDBStepperStep itemId={10} icon='10' text='step10'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
  
                <MDBStepperStep itemId={11} icon='11' text='step11'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
  
                <MDBStepperStep itemId={12} icon='12' text='step12'>
                  Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
                </MDBStepperStep>
              </MDBStepper>
            );
          }
        
        
    

Custom icons

if you want to use an icon instead of a step number you can do it by setting MDBStepperHead icon property.

  • step1
    invalid
  • step2
    invalid
  • step3
    invalid
        
            
            import React, { useState } from 'react';
            import { 
              MDBStepper, 
              MDBStepperStep,
              MDBInput,
              MDBIcon,
              MDBSpinner
            } from 'mdb-react-ui-kit';
            
            export default function App() {
              return (
                <MDBStepper>
                  <MDBStepperStep headIcon={<MDBIcon fas icon='user' />} headText='step 1' itemId={1}>
                    <MDBInput label='step 1' />
                  </MDBStepperStep>
    
                  <MDBStepperStep headIcon={<MDBIcon fas icon='envelope' />} headText='step 2' itemId={2}>
                    <MDBInput label='step 2' />
                  </MDBStepperStep>
    
                  <MDBStepperStep headIcon={<MDBSpinner size='sm' />} headText='step 3' itemId={3}>
                    <MDBInput label='step 3' />
                  </MDBStepperStep>
                </MDBStepper>
              );
            }
          
        
    

Form wizard

An example of so-called "Form wizard" with multiple inputs on each step.

  • 1 step1
    invalid
    invalid
  • 2 step2
    invalid
    invalid
    invalid
    invalid
  • 3 step3
        
            
            import React, { useState, useEffect, useRef } from 'react';
            import { 
              MDBStepper, 
              MDBStepperStep,
              MDBStepperForm,
              MDBInput,
              MDBCheckbox,
              MDBBtn,
              MDBValidationItem,
              MDBTextArea
            } from 'mdb-react-ui-kit';
            
            export default function App() {
              const wizardNextRef = useRef(null);
              const wizardPrevRef = useRef(null);
            
              const [wizardRefs, setWizardRefs] = useState<{
                prev: React.MutableRefObject<any> | null;
                next: React.MutableRefObject<any> | null;
              }>({ prev: null, next: null });

              useEffect(() => {
                setWizardRefs({ prev: wizardPrevRef, next: wizardNextRef });
              }, [wizardNextRef, wizardPrevRef]);

              return (
                <>
                  <MDBStepper externalNext={wizardRefs.next} externalPrev={wizardRefs.prev} linear>
                    <MDBStepperForm>
                      <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBInput
                            wrapperClass='mb-4'
                            label={
                              <>
                                First name <small className='text-muted'>(required)</small>
                              </>
                            }
                            required
                          />
                        </MDBValidationItem>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBInput
                            wrapperClass='mb-4'
                            label={
                              <>
                                Last name <small className='text-muted'>(required)</small>
                              </>
                            }
                            required
                          />
                        </MDBValidationItem>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBInput
                            wrapperClass='mb-4'
                            label={
                              <>
                                Nickname <small className='text-muted'>(required)</small>
                              </>
                            }
                            required
                          />
                        </MDBValidationItem>
                      </MDBStepperStep>
      
                      <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBInput
                            wrapperClass='mb-4'
                            label={
                              <>
                                Company name <small className='text-muted'>(required)</small>
                              </>
                            }
                            required
                          />
                        </MDBValidationItem>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBInput
                            wrapperClass='mb-4'
                            label={
                              <>
                                Address <small className='text-muted'>(required)</small>
                              </>
                            }
                            required
                          />
                        </MDBValidationItem>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBInput
                            wrapperClass='mb-4'
                            type='email'
                            label={
                              <>
                                Email <small className='text-muted'>(required)</small>
                              </>
                            }
                            required
                          />
                        </MDBValidationItem>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBInput
                            wrapperClass='mb-4'
                            type='number'
                            label={
                              <>
                                Phone <small className='text-muted'>(optional)</small>
                              </>
                            }
                          />
                        </MDBValidationItem>
                      </MDBStepperStep>
      
                      <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                        <MDBValidationItem invalid feedback='invalid'>
                          <MDBTextArea rows={4} wrapperClass='mb-4' label='Additional information' required />
                        </MDBValidationItem>
      
                        <MDBValidationItem feedback=''>
                          <MDBCheckbox
                            wrapperClass='d-flex justify-content-center mb-4'
                            label='Create an account?'
                            required
                          />
                        </MDBValidationItem>
      
                        <MDBBtn type='submit' block color='success' className='mb-4'>
                          Place order
                        </MDBBtn>
                      </MDBStepperStep>
                    </MDBStepperForm>
                  </MDBStepper>
                  <MDBBtn className='w-50' ref={wizardPrevRef}>
                    previous step
                  </MDBBtn>
                  <MDBBtn className='w-50' ref={wizardNextRef}>
                    next step
                  </MDBBtn>
                </>
              );
            }
          
        
    

Toggle to vertical or mobile on smaller screens

Change the stepper mode depending on window width.

  • step1
    invalid
  • step2
    invalid
  • step3
    invalid
        
            
            import React, { useState, useEffect, useCallback } from 'react';
            import { 
              MDBStepper, 
              MDBStepperStep,
              MDBInput,
              MDBIcon,
              MDBSpinner
            } from 'mdb-react-ui-kit';
            
            export default function App() {
              const [mode, setMode] = useState<'horizontal' | 'vertical' | 'mobile'>('horizontal');

              const handleResize = useCallback(() => {
                const width = window.innerWidth;
            
                if (width > 768) {
                  setMode('horizontal');
                } else if (width <= 768 && width > 400) {
                  setMode('vertical');
                } else {
                  setMode('mobile');
                }
              }, []);
            
              useEffect(() => {
                window.addEventListener('resize', handleResize);
            
                return () => {
                  window.removeEventListener('resize', handleResize);
                };
              }, [handleResize]);

              return (
                <MDBStepper type={mode}>
                  <MDBStepperStep headIcon={<MDBIcon fas icon='user' />} headText='step 1' itemId={1}>
                    <MDBInput label='step 1' />
                  </MDBStepperStep>
    
                  <MDBStepperStep headIcon={<MDBIcon fas icon='envelope' />} headText='step 2' itemId={2}>
                    <MDBInput label='step 2' />
                  </MDBStepperStep>
    
                  <MDBStepperStep headIcon={<MDBSpinner size='sm' />} headText='step 3' itemId={3}>
                    <MDBInput label='step 3' />
                  </MDBStepperStep>
                </MDBStepper>
              );
            }
          
        
    

Events

Stepper emits events after successful step validation, after failed step validation, and before changing to another step. Check the browser console and try to change the step to see the result.

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            import React from 'react';
            import { 
              MDBStepper, 
              MDBStepperStep,
              MDBValidationItem,
              MDBInput,
              MDBStepperForm,
              MDBBtn
            } from 'mdb-react-ui-kit';
            
            export default function App() {
              return (
                <MDBStepper
                  onValid={(id) => console.log('onValid')}
                  onInvalid={(id) => console.log('onInvalid')}
                  onChange={(id) => console.log('onChangeStep')}
                  linear
                >
                  <MDBStepperForm>
                    <MDBStepperStep headIcon={1} headText='step 1' itemId={1}>
                      <MDBValidationItem invalid feedback='invalid'>
                        <MDBInput label='step 1' required />
                      </MDBValidationItem>
                    </MDBStepperStep>
    
                    <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                      <MDBValidationItem invalid feedback='invalid'>
                        <MDBInput label='step 2' required />
                      </MDBValidationItem>
                    </MDBStepperStep>
    
                    <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                      <MDBValidationItem invalid feedback='invalid'>
                        <MDBInput wrapperClass='mb-4' label='step 3' required />
                        <MDBBtn type='submit'>submit</MDBBtn>
                      </MDBValidationItem>
                    </MDBStepperStep>
                  </MDBStepperForm>
                </MDBStepper>
              );
            }
          
        
    

Add custom validation

You can use the customValidation method with MDBStepperStep component to use your own validation.

  • 1 step1
    Password should have 5 or more characters
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            import React from 'react';
            import { 
              MDBStepper, 
              MDBStepperStep,
              MDBValidationItem,
              MDBBtn,
              MDBInput,
              MDBStepperForm
            } from 'mdb-react-ui-kit';
            
            export default function App() {
              return (
                <MDBStepper linear>
                  <MDBStepperForm>
                    <MDBStepperStep
                      customValidation={(input: HTMLInputElement) => {
                        const inputLenght = input.value.length;

                        if (inputLenght < 5) {
                          input.setCustomValidity('Invalid');
                        } else {
                          input.setCustomValidity('');
                        }

                        return inputLenght >= 5;
                      }}
                      headIcon={1}
                      headText='step 1'
                      itemId={1}
                    >
                      <MDBValidationItem invalid feedback='password must have 5 sings'>
                        <MDBInput type='password' label='step 1' required />
                      </MDBValidationItem>
                    </MDBStepperStep>

                    <MDBStepperStep headIcon={2} headText='step 2' itemId={2}>
                      <MDBValidationItem invalid feedback='invalid'>
                        <MDBInput label='step 2' required />
                      </MDBValidationItem>
                    </MDBStepperStep>

                    <MDBStepperStep headIcon={3} headText='step 3' itemId={3}>
                      <MDBValidationItem invalid feedback='invalid'>
                        <MDBInput wrapperClass='mb-4' label='step 3' required />
                        <MDBBtn type='submit'>submit</MDBBtn>
                      </MDBValidationItem>
                    </MDBStepperStep>
                  </MDBStepperForm>
                </MDBStepper>
              );
            }
          
        
    

PAY ONCE

USE FOREVER

Hurry up ⌛ claim exclusive long term passes available only during Cyber Weeks

Stepper - API


Import

        
            
        import { 
          MDBStepper,
          MDBStepperStep,
          MDBStepperForm,
        } from 'mdb-react-ui-kit';
      
        
    

Properties

MDBStepper

Name Type Default Description Example
defaultStep number 1 Change default step of the stepper. <MDBStepper defaultStep={3} />
disableHeadSteps boolean false Disable stepper head onClick change. <MDBStepper disableHeadSteps />
externalNext React.MutableRefObject null Reference to the external element, to change the stepper step to the next. <MDBStepper externalNext={nextRef} />
externalPrev React.MutableRefObject null Reference to the external element, to change the stepper step to the previous. <MDBStepper externalPrev={prevRef} />
linear boolean false Set to true to use the linear stepper <MDBStepper linear />
mobileOfLabel React.ReactNode 'of' Set custom of value in the mobile stepper head. <MDBStepper mobileOfLabel='at' />
mobileStepLabel React.ReactNode 'step' Set custom step value in the mobile stepper head. <MDBStepper mobileStepLabel='element' />
mobileBackLabel React.ReactNode 'BACK' Set custom text for BACK button. <MDBStepper mobileBackLabel='PREV' />
mobileNextLabel React.ReactNode 'NEXT' Set custom text for NEXT button. <MDBStepper mobileNextLabel='NXT' />
mobileProgress boolean false Enable mobile progress stepper. <MDBStepper type='mobile' mobileProgress />
noEditable boolean false Set to true to block editing of the completed step. <MDBStepper noEditable />
type 'horizontal' | 'vertical' | 'mobile' 'horizontal' Set the stepper view <MDBStepper type='vertical' />

MDBStepperStep

Name Type Default Description Example
contentClassName string '' Add custom classes to content element. <MDBStepperStep contentClassName="class" />
contentStyle React.CSSProperties - Add custom styles to content element. <MDBStepperStep contentStyle={customStyles} />
itemId number - Set the step unique id. <MDBStepperStep itemId={1} />
headClassName string '' Add custom classes to head element. <MDBStepperStep headClassName="class" />
headStyle React.CSSProperties - Add custom styles to head element. <MDBStepperStep headStyle={customStyles} />
headIcon React.ReactNode '0' Set step head icon. <MDBStepperStep headIcon='6' />
headText React.ReactNode 'none' Set step head text. <MDBStepperStep headText='step element' />

MDBStepperForm

For MDBStepperForm propeties check the MDBValidation properties.


Methods

MDBStepperStep

Name Type Description
customValidation (input: HTMLInputElement) => boolean Apply custom validation to the step.

Events

MDBStepper

Name Type Description
onChange (id: number) => void Event emitted before the step change.
onInvalid (id: number) => void Event emitted after unsuccessful step validation.
onValid (id: number) => void Event emitted after successful step validation.

CSS variables

As part of MDB’s evolving CSS variables approach, stepper now use local CSS variables on .stepper for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

        
            
          // .steps
          --#{$prefix}steps-transition: #{$steps-transition};

          // .steps-step
          --#{$prefix}steps-step-after-left: #{$steps-step-after-left};
          --#{$prefix}steps-step-after-width: #{$steps-step-after-width};
          --#{$prefix}steps-step-after-margin-top: #{$steps-step-after-margin-top};
          --#{$prefix}steps-step-after-bg: #{$steps-step-after-bg};

          // .steps-content
          --#{$prefix}steps-content-padding-y: #{$steps-content-padding-y};

          // .steps-head-vertical
          --#{$prefix}steps-head-vertical-padding-top: #{$steps-head-vertical-padding-top};
          --#{$prefix}steps-head-vertical-padding-x: #{$steps-head-vertical-padding-x};

          // .steps-head-icon-vertical
          --#{$prefix}steps-head-icon-vertical-margin-right: #{$steps-head-icon-vertical-margin-right};

          // .steps-head
          --#{$prefix}steps-head-line-height: #{$steps-head-line-height};
          --#{$prefix}steps-head-hover-bgc: #{$steps-head-hover-bgc};

          // .steps-head-text
          --#{$prefix}steps-head-text-color: #{$steps-head-text-color};
          --#{$prefix}steps-head-text-after-font-size: #{$steps-head-text-after-font-size};

          // .steps-head-icon
          --#{$prefix}steps-head-icon-font-size: #{$steps-head-icon-font-size};
          --#{$prefix}steps-head-icon-width: #{$steps-head-icon-width};
          --#{$prefix}steps-head-icon-height: #{$steps-head-icon-height};
          --#{$prefix}steps-head-icon-font-weight: #{$steps-head-icon-font-weight};

          // .steps-active-head-text
          --#{$prefix}steps-active-head-text-font-weight: #{$steps-active-head-text-font-weight};
          
          // .stepper
          --#{$prefix}stepper-padding-x: #{$stepper-padding-x};
          --#{$prefix}stepper-step-height: #{$stepper-step-height};
          --#{$prefix}stepper-step-head-padding-left: #{$stepper-step-head-padding-left};
          --#{$prefix}stepper-step-head-padding-right: #{$stepper-step-head-padding-right};
          --#{$prefix}stepper-step-head-height: #{$stepper-step-head-height};
          --#{$prefix}stepper-step-head-bg: #{$stepper-step-head-bg};
          --#{$prefix}stepper-step-head-margin-right: #{$stepper-step-head-margin-right};
          --#{$prefix}stepper-step-head-margin-left: #{$stepper-step-head-margin-left};
          --#{$prefix}stepper-head-icon-margin-y: #{$stepper-head-icon-margin-y};
          --#{$prefix}stepper-head-icon-margin-right: #{$stepper-head-icon-margin-right};
          --#{$prefix}stepper-vertical-step-top: #{$stepper-vertical-step-top};
          --#{$prefix}stepper-vertical-step-height: #{$stepper-vertical-step-height};
          --#{$prefix}stepper-vertical-content-padding-left: #{$stepper-vertical-content-padding-left};
          --#{$prefix}stepper-vertical-content-transition: #{$stepper-vertical-content-transition};
          --#{$prefix}stepper-vertical-head-padding-bottom: #{$stepper-vertical-head-padding-bottom};
          --#{$prefix}stepper-mobile-step-margin-y: #{$stepper-mobile-step-margin-y};
          --#{$prefix}stepper-mobile-step-head-padding-x: #{$stepper-mobile-step-head-padding-x};
          --#{$prefix}stepper-mobile-head-icon-height: #{$stepper-mobile-head-icon-height};
          --#{$prefix}stepper-mobile-head-icon-width: #{$stepper-mobile-head-icon-width};
          --#{$prefix}stepper-mobile-content-top: #{$stepper-mobile-content-top};
          --#{$prefix}stepper-mobile-active-head-icon-bg: #{$stepper-mobile-active-head-icon-bg};
          --#{$prefix}stepper-mobile-completed-head-icon-bg: #{$stepper-mobile-completed-head-icon-bg};
          --#{$prefix}stepper-head-icon-bg: #{$stepper-head-icon-bg};
          --#{$prefix}stepper-head-icon-color: #{$stepper-head-icon-color};
          --#{$prefix}stepper-completed-head-icon-bg: #{$stepper-completed-head-icon-bg};
          --#{$prefix}stepper-completed-head-icon-color: #{$stepper-completed-head-icon-color};
          --#{$prefix}stepper-active-head-icon-bg: #{$stepper-active-head-icon-bg};
          --#{$prefix}stepper-active-head-icon-color: #{$stepper-active-head-icon-color};
          --#{$prefix}stepper-invalid-head-icon-bg: #{$stepper-invalid-head-icon-bg};
          --#{$prefix}stepper-invalid-head-icon-color: #{$stepper-invalid-head-icon-color};
          --#{$prefix}stepper-disabled-head-color: #{$stepper-disabled-head-color};
          --#{$prefix}stepper-disabled-head-icon-bg: #{$stepper-disabled-head-icon-bg};
          --#{$prefix}stepper-disabled-head-icon-color: #{$stepper-disabled-head-icon-color};
          --#{$prefix}stepper-mobile-head-padding-y: #{$stepper-mobile-head-padding-y};
          --#{$prefix}stepper-mobile-head-padding-x: #{$stepper-mobile-head-padding-x};
          --#{$prefix}stepper-mobile-footer-height: #{$stepper-mobile-footer-height};
          --#{$prefix}stepper-back-btn-i-margin-right: #{$stepper-back-btn-i-margin-right};
          --#{$prefix}stepper-next-btn-i-margin-left: #{$stepper-next-btn-i-margin-left};
          --#{$prefix}stepper-mobile-progress-bar-height: #{$stepper-mobile-progress-bar-height};
          --#{$prefix}stepper-mobile-progress-height: #{$stepper-mobile-progress-height};
          --#{$prefix}stepper-mobile-progress-background-color: #{$stepper-mobile-progress-background-color};
          
        
    

SCSS variables

        
            
        // Steps
        $steps-transition: height 0.2s ease-in-out;
        
        $steps-step-after-left: 2.45rem;
        $steps-step-after-width: 1px;
        $steps-step-after-margin-top: 0.5rem;
        $steps-step-after-bg: #dfdfdf;
        
        $steps-content-padding-y: 1.5rem;
        
        $steps-head-vertical-padding-top: 1.5rem;
        $steps-head-vertical-padding-x: 1.5rem;
        
        $steps-head-icon-vertical-margin-right: 0.75rem;
        
        $steps-head-line-height: 1.3;
        $steps-head-hover-bgc: rgba(0, 0, 0, 0.025);
        
        $steps-head-text-color: $text-muted;
        $steps-head-text-after-font-size: 0.8rem;
        
        $steps-head-icon-font-size: 0.875rem;
        $steps-head-icon-width: 1.938rem;
        $steps-head-icon-height: 1.938rem;
        $steps-head-icon-font-weight: 500;
        
        $steps-active-head-text-font-weight: 500;
        
        // Stepper
        $stepper-padding-x: 1rem;
        
        $stepper-step-height: 4.5rem;
        
        $stepper-step-head-padding-left: 1.5rem;
        $stepper-step-head-padding-right: 1.5rem;
        $stepper-step-head-height: 1px;
        $stepper-step-head-bg: rgba(0, 0, 0, 0.1);
        $stepper-step-head-margin-right: 0.5rem;
        $stepper-step-head-margin-left: 0.5rem;
        
        $stepper-head-icon-margin-y: 1.5rem;
        $stepper-head-icon-margin-right: 0.5rem;
        
        $stepper-vertical-step-top: 3.25rem;
        $stepper-vertical-step-height: calc(100% - 2.45rem);
        $stepper-vertical-content-padding-left: 3.75rem;
        $stepper-vertical-content-transition: height 0.3s ease-in-out, margin-top 0.3s ease-in-out,
          margin-bottom 0.3s ease-in-out, padding-top 0.3s ease-in-out, padding-bottom 0.3s ease-in-out;
        $stepper-vertical-head-padding-bottom: 1.5rem;
        
        $stepper-mobile-step-margin-y: 1rem;
        $stepper-mobile-step-head-padding-x: 0.25rem;
        $stepper-mobile-head-icon-height: 0.5rem;
        $stepper-mobile-head-icon-width: 0.5rem;
        $stepper-mobile-content-top: 2.56rem;
        $stepper-mobile-active-head-icon-bg: rgb(55, 111, 200);
        $stepper-mobile-completed-head-icon-bg: rgb(19, 150, 71);
        
        $stepper-head-icon-bg: rgb(235, 237, 239);
        $stepper-head-icon-color: rgb(64, 70, 79);
        
        $stepper-completed-head-icon-bg: rgb(214, 240, 224);
        $stepper-completed-head-icon-color: rgb(13, 104, 50);
        
        $stepper-active-head-icon-bg: rgb(223, 231, 246);
        $stepper-active-head-icon-color: rgb(44, 88, 160);
        
        $stepper-invalid-head-icon-bg: rgb(249, 225, 229);
        $stepper-invalid-head-icon-color: rgb(175, 35, 58);
        
        $stepper-disabled-head-color: #808080;
        $stepper-disabled-head-icon-bg: #e6e6e6;
        $stepper-disabled-head-icon-color: #808080;
        
        $stepper-mobile-head-padding-y: 0.5rem;
        $stepper-mobile-head-padding-x: 1rem;
        $stepper-mobile-footer-height: 2.5rem;
        
        $stepper-back-btn-i-margin-right: 0.5rem;
        $stepper-next-btn-i-margin-left: 0.5rem;
        
        $stepper-mobile-progress-bar-height: 0.3rem;
        $stepper-mobile-progress-height: 0.3rem;
        $stepper-mobile-progress-background-color: $gray-300;

Stepper

Angular Bootstrap 5 Stepper / Wizard component

Responsive stepper built with Bootstrap 5, Angular and Material Design. Form wizard, vertical stepper, multi step form validation, optional step, mobile stepper & more

Stepper is a component that displays content as a process with defined by user milestones. This is a great solution for a variety of registration forms, where you don't want to scare the user with lots of fields and questions.

In this documentation, you can find examples of form wizard, vertical stepper, horizontal stepper, multi step form, mobile stepper, validation & more.

Note: Read the API tab to find all available options and advanced customization


Basic example

Initialize the stepper component using the code below.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <mdb-stepper>
              <mdb-step *ngFor="let step of steps" [name]="step.name">
                {{ step.content }}
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              steps = [
                {
                  name: 'Step 1',
                  content:
                    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                },
                {
                  name: 'Step 2',
                  content:
                    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                },
                {
                  name: 'Step 3',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
              ];
            }
          
        
    

Change steps using external elements

To go to the next or previous step, you can use the nextStep and previousStep methods. You can also choose a specific step using the changeStep method by entering the step index

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <div class="mb-3">
              <button id="prev-step" class="btn btn-primary" (click)="stepper.previous()">
                prev
              </button>
              <button id="step-1" class="btn btn-primary" (click)="stepper.setNewActiveStep(0)">
                step1
              </button>
              <button id="step-2" class="btn btn-primary" (click)="stepper.setNewActiveStep(1)">
                step2
              </button>
              <button id="step-3" class="btn btn-primary" (click)="stepper.setNewActiveStep(2)">
                step3
              </button>
              <button id="next-step" class="btn btn-primary" (click)="stepper.next()">next</button>
            </div>
            <mdb-stepper #stepper>
              <mdb-step *ngFor="let step of steps" [name]="step.name">
                {{ step.content }}
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              steps = [
                {
                  name: 'Step 1',
                  content:
                    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                },
                {
                  name: 'Step 2',
                  content:
                    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                },
                {
                  name: 'Step 3',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
              ];
            }
          
        
    

Linear stepper

Use [linear]="true" input to enable linear stepper. Linear stepper requires the users to complete previous steps before proceeding to following steps.

  • 1 step1
    invalid
  • 2 step2
    invalid
  • 3 step3
    invalid
        
            
            <mdb-stepper [linear]="true">
              <mdb-step [stepForm]="firstFormGroup" [name]="'Step 1'">
                <form [formGroup]="firstFormGroup">
                  <mdb-form-control>
                    <input
                      mdbInput
                      mdbValidate
                      type="text"
                      id="step1"
                      class="form-control"
                      formControlName="firstStep"
                    />
                    <label mdbLabel class="form-label" for="step1">Step 1</label>
                  </mdb-form-control>
                </form>
              </mdb-step>
              <mdb-step [stepForm]="secondFormGroup" [name]="'Step 2'">
                <form [formGroup]="secondFormGroup">
                  <mdb-form-control>
                    <input
                      mdbInput
                      mdbValidate
                      type="text"
                      id="step2"
                      class="form-control"
                      formControlName="secondStep"
                    />
                    <label mdbLabel class="form-label" for="step2">Step 2</label>
                  </mdb-form-control>
                </form>
              </mdb-step>
              <mdb-step [name]="'Step 3'">
                <mdb-form-control>
                  <input mdbInput mdbValidate type="text" id="step3" class="form-control" />
                  <label mdbLabel class="form-label" for="step3">Step 3</label>
                </mdb-form-control>
                <button class="btn btn-primary" type="submit">Submit</button>
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { FormGroup, FormControl, Validators } from '@angular/forms';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              firstFormGroup: FormGroup;
              secondFormGroup: FormGroup;

              constructor() {
                this.firstFormGroup = new FormGroup({
                  firstStep: new FormControl('', [Validators.required]),
                });

                this.secondFormGroup = new FormGroup({
                  secondStep: new FormControl('', Validators.required),
                });
              }

              get firstStep() {
                return this.firstFormGroup.get('firstStep');
              }
              get secondStep() {
                return this.secondFormGroup.get('secondStep');
              }
            }
          
        
    

No editable stepper

You can use [editable]="false"input on mdb-step to prevent from editing the completed step again.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <mdb-stepper>
              <mdb-step *ngFor="let step of steps" [name]="step.name" [editable]="false">
                {{ step.content }}
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              steps = [
                {
                  name: 'Step 1',
                  content:
                    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                },
                {
                  name: 'Step 2',
                  content:
                    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                },
                {
                  name: 'Step 3',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
              ];
            }
          
        
    

Vertical stepper

Use [orientation]="'vertical'" to change stepper orientation to vertical.

  • 1 step1
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 2 step2
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
  • 3 step3
    Lorem ipsum dolor sit amet enim. Etiam ullamcorper. Suspendisse a pellentesque dui, non felis. Maecenas malesuada elit lectus felis, malesuada ultricies.
        
            
            <mdb-stepper [orientation]="'vertical'">
              <mdb-step *ngFor="let step of steps" [name]="step.name" [editable]="false">
                {{ step.content }}
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              steps = [
                {
                  name: 'Step 1',
                  content:
                    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                },
                {
                  name: 'Step 2',
                  content:
                    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                },
                {
                  name: 'Step 3',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
              ];
            }
          
        
    

Mobile stepper

Use [mobile]="true"input on stepper with horizontal orientation to change component view to mobile.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <mdb-stepper [mobile]="true">
              <mdb-step *ngFor="let step of steps" [name]="step.name">
                {{ step.content }}
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              steps = [
                {
                  name: 'Step 1',
                  content:
                    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                },
                {
                  name: 'Step 2',
                  content:
                    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                },
                {
                  name: 'Step 3',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
              ];
            }
          
        
    

Mobile stepper progress bar

If the mobile stepper contains more than 4 steps, the progress bar will be displayed by default instead of dots. You can edit the step limit with the mobileBarBreakpoint input.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 4 step4
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
  • 4 step4
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <mdb-stepper [mobile]="true">
              <mdb-step *ngFor="let step of steps" [name]="step.name">
                {{ step.content }}
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              steps = [
                {
                  name: 'Step 1',
                  content:
                    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                },
                {
                  name: 'Step 2',
                  content:
                    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                },
                {
                  name: 'Step 3',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
                {
                  name: 'Step 4',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
                {
                  name: 'Step 5',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
              ];
            }
          
        
    

Optional step

You can mark a step as optional by adding [optional]="true" to it.

  • 1 step1
  • 2 step2
  • 3 step3
        
            
            <mdb-stepper [linear]="true">
              <mdb-step [stepForm]="firstFormGroup" [name]="'Step 1'">
                <form [formGroup]="firstFormGroup">
                  <mdb-form-control>
                    <input
                      mdbInput
                      mdbValidate
                      type="text"
                      id="step1"
                      class="form-control"
                      formControlName="firstStep"
                    />
                    <label mdbLabel class="form-label" for="step1">Step 1</label>
                  </mdb-form-control>
                </form>
              </mdb-step>
              <mdb-step [stepForm]="secondFormGroup" [name]="'Step 2'" [optional]="true">
                <form [formGroup]="secondFormGroup">
                  <mdb-form-control>
                    <input
                      mdbInput
                      mdbValidate
                      type="text"
                      id="step2"
                      class="form-control"
                      formControlName="secondStep"
                    />
                    <label mdbLabel class="form-label" for="step2">Step 2</label>
                  </mdb-form-control>
                </form>
              </mdb-step>
              <mdb-step [name]="'Step 3'">
                <mdb-form-control>
                  <input mdbInput mdbValidate type="text" id="step3" class="form-control" />
                  <label mdbLabel class="form-label" for="step3">Step 3</label>
                </mdb-form-control>
                <button class="btn btn-primary" type="submit">Submit</button>
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { FormGroup, FormControl, Validators } from '@angular/forms';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              firstFormGroup: FormGroup;
              secondFormGroup: FormGroup;

              constructor() {
                this.firstFormGroup = new FormGroup({
                  firstStep: new FormControl('', [Validators.required]),
                });

                this.secondFormGroup = new FormGroup({
                  secondStep: new FormControl('', Validators.required),
                });
              }
            }
          
        
    

Custom header

If you want to create a more detailed header you can do it by placing HTML code inside ng-template with mdbStepHeader directive.

  • 1

    Heading

    Subheading

    Total Sum: $100
  • 2 Step2
  • 3 step3
        
            
          <mdb-stepper>
            <mdb-step>
              <ng-template mdbStepHeader>
                <div class="container">
                  <div class="row">
                    <div class="col-auto d-flex flex-column">
                      <p class="mb-auto h4">Heading</p>
                      <p class="text-muted mb-2 pt-2"><small>Subheading</small></p>
                    </div>
                    <div class="col-auto d-flex align-items-center justify-content-center">
                      <span>Total Sum: <strong>$100</strong></span>
                    </div>
                  </div>
                </div>
              </ng-template>
              <mdb-form-control>
                <input mdbInput mdbValidate type="text" id="icon1" class="form-control" />
                <label mdbLabel class="form-label" for="icon1">Step 1</label>
              </mdb-form-control>
            </mdb-step>
  
            <mdb-step [name]="'Step 2'">
              <mdb-form-control>
                <input mdbInput mdbValidate type="text" id="icon2" class="form-control" />
                <label mdbLabel class="form-label" for="icon2">Step 2</label>
              </mdb-form-control>
            </mdb-step>
  
            <mdb-step [name]="'Step 3'">
              <mdb-form-control>
                <input mdbInput mdbValidate type="text" id="icon3" class="form-control" />
                <label mdbLabel class="form-label" for="icon3">Step 3</label>
              </mdb-form-control>
            </mdb-step>
          </mdb-stepper>
          
        
    

Custom icons

If you want to use an icon instead of a step number you can do it by placing icon HTML code inside ng-template with mdbStepIcon directive.

  • step1
  • step2
  • step3
        
            
            <mdb-stepper>
              <mdb-step [name]="'Step 1'">
                <ng-template mdbStepIcon>
                  <i class="fas fa-user"></i>
                </ng-template>

                <mdb-form-control>
                  <input mdbInput mdbValidate type="text" id="icon1" class="form-control" />
                  <label mdbLabel class="form-label" for="icon1">Step 1</label>
                </mdb-form-control>
              </mdb-step>

              <mdb-step [name]="'Step 2'">
                <ng-template mdbStepIcon>
                  <i class="fas fa-envelope"></i>
                </ng-template>

                <mdb-form-control>
                  <input mdbInput mdbValidate type="text" id="icon2" class="form-control" />
                  <label mdbLabel class="form-label" for="icon2">Step 2</label>
                </mdb-form-control>
              </mdb-step>

              <mdb-step [name]="'Step 3'">
                <ng-template mdbStepIcon>
                  <span
                    class="spinner-border spinner-border-sm"
                    role="status"
                    aria-hidden="true"
                  ></span>
                </ng-template>

                <mdb-form-control>
                  <input mdbInput mdbValidate type="text" id="icon3" class="form-control" />
                  <label mdbLabel class="form-label" for="icon3">Step 3</label>
                </mdb-form-control>
              </mdb-step>
            </mdb-stepper>
          
        
    

Form wizard

An example of so-called "Form wizard" with multiple inputs on each step.

  • 1 step1
    invalid
    invalid
  • 2 step2
    invalid
    invalid
    invalid
    invalid
  • 3 step3
        
            
          <mdb-stepper #stepper [linear]="true">
            <mdb-step [stepForm]="firstFormGroup" [name]="'Step 1'">
              <form [formGroup]="firstFormGroup">
                <mdb-form-control>
                  <input
                    mdbInput
                    mdbValidate
                    type="text"
                    id="first-name"
                    class="form-control mb-4"
                    formControlName="firstName"
                  />
                  <label mdbLabel class="form-label" for="first-name"
                    >First name <span class="text-muted">(required)</span></label
                  >
                </mdb-form-control>
  
                <mdb-form-control>
                  <input
                    mdbInput
                    mdbValidate
                    type="text"
                    id="last-name"
                    class="form-control mb-4"
                    formControlName="lastName"
                  />
                  <label mdbLabel class="form-label" for="last-name"
                    >Last name <span class="text-muted">(required)</span></label
                  >
                </mdb-form-control>
  
                <mdb-form-control>
                  <input
                    mdbInput
                    type="text"
                    id="nickname"
                    class="form-control mb-4"
                    formControlName="nickname"
                  />
                  <label mdbLabel class="form-label" for="nickname"
                    >Nickname <small class="text-muted">(optional)</small></label
                  >
                </mdb-form-control>
              </form>
            </mdb-step>
            <mdb-step [stepForm]="secondFormGroup" [name]="'Step 2'">
              <form [formGroup]="secondFormGroup">
                <mdb-form-control>
                  <input
                    mdbInput
                    mdbValidate
                    type="text"
                    id="company-name"
                    class="form-control mb-4"
                    formControlName="companyName"
                  />
                  <label mdbLabel class="form-label" for="company-name"
                    >Company name <span class="text-muted">(required)</span></label
                  >
                </mdb-form-control>
  
                <mdb-form-control>
                  <input
                    mdbInput
                    mdbValidate
                    type="text"
                    id="address"
                    class="form-control mb-4"
                    formControlName="address"
                  />
                  <label mdbLabel class="form-label" for="address"
                    >Address <span class="text-muted">(required)</span></label
                  >
                </mdb-form-control>
  
                <mdb-form-control>
                  <input
                    mdbInput
                    mdbValidate
                    type="text"
                    id="email"
                    class="form-control mb-4"
                    formControlName="email"
                  />
                  <label mdbLabel class="form-label" for="email"
                    >Email <span class="text-muted">(required)</span></label
                  >
                </mdb-form-control>
  
                <mdb-form-control>
                  <input
                    mdbInput
                    type="text"
                    id="phone"
                    class="form-control mb-4"
                    formControlName="phone"
                  />
                  <label mdbLabel class="form-label" for="phone"
                    >Phone <small class="text-muted">(optional)</small></label
                  >
                </mdb-form-control>
              </form>
            </mdb-step>
            <mdb-step [name]="'Step 3'">
              <mdb-form-control class="mb-4">
                <textarea mdbInput class="form-control" id="additional-info" rows="4"></textarea>
                <label mdbLabel class="form-label" for="additional-info"
                  >Additional information</label
                >
              </mdb-form-control>
  
              <div class="form-check d-flex justify-content-center mb-4">
                <input
                  mdbCheckbox
                  class="form-check-input me-2"
                  type="checkbox"
                  value=""
                  id="crate-account"
                  [checked]="true"
                />
                <label class="form-check-label" for="create-account"> Create an account? </label>
              </div>
  
              <button type="submit" class="btn btn-success btn-block mb-4">Place order</button>
            </mdb-step>
          </mdb-stepper>
  
          <!-- Buttons -->
          <div class="d-flex justify-content-center px-3">
            <button
              id="form-example-prev-step"
              class="btn btn-primary w-100 me-2"
              (click)="stepper.previous()"
            >
              Previous step
            </button>
            <button
              id="form-example-next-step"
              class="btn btn-primary w-100"
              (click)="stepper.next()"
            >
              Next step
            </button>
          </div>
          <!-- Buttons -->
          
        
    
        
            
            import { Component } from '@angular/core';
            import { FormGroup, FormControl, Validators } from '@angular/forms';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              firstFormGroup: FormGroup;
              secondFormGroup: FormGroup;

              constructor() {
                this.firstFormGroup = new FormGroup({
                  firstName: new FormControl('', [Validators.required]),
                  lastName: new FormControl('', [Validators.required]),
                  nickname: new FormControl(''),
                });

                this.secondFormGroup = new FormGroup({
                  companyName: new FormControl('', [Validators.required]),
                  address: new FormControl('', [Validators.required]),
                  email: new FormControl('', [Validators.required, Validators.email]),
                  phone: new FormControl(''),
                });
              }
            }
          
        
    

Toggle to vertical or mobile on smaller screens

Change the view from horizontal to vertical or mobile with smaller screens using code below.

  • 1 step1
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua
  • 2 step2
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
  • 3 step3
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur
        
            
            <mdb-stepper [orientation]="orientation" [mobile]="isMobile">
              <mdb-step *ngFor="let step of steps" [name]="step.name">
                {{ step.content }}
              </mdb-step>
            </mdb-stepper>
          
        
    
        
            
            import { Component, OnInit, NgZone } from '@angular/core';
            import { MdbStepperOrientation } from 'mdb-angular-ui-kit/stepper';
            import { fromEvent } from 'rxjs';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent implements OnInit {
              steps = [
                {
                  name: 'Step 1',
                  content:
                    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                },
                {
                  name: 'Step 2',
                  content:
                    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                },
                {
                  name: 'Step 3',
                  content:
                    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                },
              ];

              verticalBreakpoint = 768;
              mobileBreakpoint = 400;

              orientation: MdbStepperOrientation =
                window.innerWidth <= this.verticalBreakpoint &&
                window.innerWidth > this.mobileBreakpoint
                  ? 'vertical'
                  : 'horizontal';
              isMobile = window.innerWidth <= this.mobileBreakpoint ? true : false;

              constructor(private _ngZone: NgZone) {}

              ngOnInit(): void {
                this._ngZone.runOutsideAngular(() => {
                  fromEvent(window, 'resize').subscribe(() => {
                    if (window.innerWidth <= this.verticalBreakpoint) {
                      this._ngZone.run(() => {
                        this.orientation = 'vertical';
                      });
                    }
                    if (window.innerWidth <= this.mobileBreakpoint) {
                      this._ngZone.run(() => {
                        this.orientation = 'horizontal';
                        this.isMobile = true;
                      });
                    }
                    if (window.innerWidth > this.verticalBreakpoint) {
                      this._ngZone.run(() => {
                        this.orientation = 'horizontal';
                        this.isMobile = false;
                      });
                    }
                  });
                });
              }
            }
          
        
    

PAY ONCE

USE FOREVER

Hurry up ⌛ claim exclusive long term passes available only during Cyber Weeks

Stepper - API


Import

        
            
          import { MdbStepperModule } from 'mdb-angular-ui-kit/stepper';
          import { ReactiveFormsModule } from '@angular/forms';

          …
          @NgModule ({
            ...
            imports: [MdbStepperModule, ReactiveFormsModule],
            ...
          })
        
        
    

Inputs

MdbStepperComponent

Name Type Default Description
linear boolean false Changes stepper mode to linear
markAsCompleted boolean true Marks previous step as completed after switching to next step
mobile boolean false Changes stepper view to mobile

MdbStepComponent

Name Type Default Description
editable boolean true Adds posibility to enable or disable step edition
name string - Changes step header name
optional boolean false Changes step to optional (works in linear mode)
stepForm FromGroup - Form group that will be validated in linear mode

Outputs

Name Type Description
stepChange EventEmitter<MdbStepChangeEvent> Event fired on active step change
        
            
              <mdb-stepper (stepChange)="onStepChange($event)">
                <mdb-step *ngFor="let step of steps" [name]="step.name">
                  {{ step.content }}
                </mdb-step>
              </mdb-stepper>
            
        
    
        
            
              import { Component } from '@angular/core';
              import { MdbStepChangeEvent } from 'mdb-angular-ui-kit/stepper';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
                styleUrls: ['./app.component.scss'],
              })
              export class AppComponent {
                steps = [
                  {
                    name: 'Step 1',
                    content:
                      'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                  },
                  {
                    name: 'Step 2',
                    content:
                      'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                  },
                  {
                    name: 'Step 3',
                    content:
                      'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                  },
                ];

                onStepChange(event: MdbStepChangeEvent) {
                  console.log(event);
                }
              }
            
        
    

Methods

Name Description Example
next Go to next step stepper.next()
newActiveStep Go to step with specific index stepper.newActiveStep(2)
previous Go to previous step stepper.previous()
        
            
              <div class="mb-3">
                <button id="prev-step" class="btn btn-primary" (click)="goToPreviousStep()">
                  Previous
                </button>
                <button id="next-step" class="btn btn-primary" (click)="goToNextStep()">Next</button>
              </div>
              <mdb-stepper #stepper>
                <mdb-step *ngFor="let step of steps" [name]="step.name">
                  {{ step.content }}
                </mdb-step>
              </mdb-stepper>
            
        
    
        
            
              import { Component, ViewChild } from '@angular/core';
              import { MdbStepperComponent } from 'mdb-angular-ui-kit/stepper';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
                styleUrls: ['./app.component.scss'],
              })
              export class AppComponent {
                @ViewChild('stepper') stepper!: MdbStepperComponent;

                steps = [
                  {
                    name: 'Step 1',
                    content:
                      'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua',
                  },
                  {
                    name: 'Step 2',
                    content:
                      'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip exea commodo consequat',
                  },
                  {
                    name: 'Step 3',
                    content:
                      'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur',
                  },
                ];

                goToNextStep(): void {
                  this.stepper.next();
                }

                goToPreviousStep(): void {
                  this.stepper.previous();
                }
              }
            
        
    

Advanced types

MdbStepChangeEvent

        
            
          interface MdbStepChangeEvent {
            activeStep: MdbStepComponent;
            activeStepIndex: number;
            previousStep: MdbStepComponent;
            previousStepIndex: number;
          }
          
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, stepper now use local CSS variables on .stepper for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

        
            
          // .steps
          --#{$prefix}steps-transition: #{$steps-transition};

          // .steps-step
          --#{$prefix}steps-step-after-left: #{$steps-step-after-left};
          --#{$prefix}steps-step-after-width: #{$steps-step-after-width};
          --#{$prefix}steps-step-after-margin-top: #{$steps-step-after-margin-top};
          --#{$prefix}steps-step-after-bg: #{$steps-step-after-bg};

          // .steps-content
          --#{$prefix}steps-content-padding-y: #{$steps-content-padding-y};

          // .steps-head-vertical
          --#{$prefix}steps-head-vertical-padding-top: #{$steps-head-vertical-padding-top};
          --#{$prefix}steps-head-vertical-padding-x: #{$steps-head-vertical-padding-x};

          // .steps-head-icon-vertical
          --#{$prefix}steps-head-icon-vertical-margin-right: #{$steps-head-icon-vertical-margin-right};

          // .steps-head
          --#{$prefix}steps-head-line-height: #{$steps-head-line-height};
          --#{$prefix}steps-head-hover-bgc: #{$steps-head-hover-bgc};

          // .steps-head-text
          --#{$prefix}steps-head-text-color: #{$steps-head-text-color};
          --#{$prefix}steps-head-text-after-font-size: #{$steps-head-text-after-font-size};

          // .steps-head-icon
          --#{$prefix}steps-head-icon-font-size: #{$steps-head-icon-font-size};
          --#{$prefix}steps-head-icon-width: #{$steps-head-icon-width};
          --#{$prefix}steps-head-icon-height: #{$steps-head-icon-height};
          --#{$prefix}steps-head-icon-font-weight: #{$steps-head-icon-font-weight};

          // .steps-active-head-text
          --#{$prefix}steps-active-head-text-font-weight: #{$steps-active-head-text-font-weight};
          
          // .stepper
          --#{$prefix}stepper-padding-x: #{$stepper-padding-x};
          --#{$prefix}stepper-step-height: #{$stepper-step-height};
          --#{$prefix}stepper-step-head-padding-left: #{$stepper-step-head-padding-left};
          --#{$prefix}stepper-step-head-padding-right: #{$stepper-step-head-padding-right};
          --#{$prefix}stepper-step-head-height: #{$stepper-step-head-height};
          --#{$prefix}stepper-step-head-bg: #{$stepper-step-head-bg};
          --#{$prefix}stepper-step-head-margin-right: #{$stepper-step-head-margin-right};
          --#{$prefix}stepper-step-head-margin-left: #{$stepper-step-head-margin-left};
          --#{$prefix}stepper-head-icon-margin-y: #{$stepper-head-icon-margin-y};
          --#{$prefix}stepper-head-icon-margin-right: #{$stepper-head-icon-margin-right};
          --#{$prefix}stepper-vertical-step-top: #{$stepper-vertical-step-top};
          --#{$prefix}stepper-vertical-step-height: #{$stepper-vertical-step-height};
          --#{$prefix}stepper-vertical-content-padding-left: #{$stepper-vertical-content-padding-left};
          --#{$prefix}stepper-vertical-content-transition: #{$stepper-vertical-content-transition};
          --#{$prefix}stepper-vertical-head-padding-bottom: #{$stepper-vertical-head-padding-bottom};
          --#{$prefix}stepper-mobile-step-margin-y: #{$stepper-mobile-step-margin-y};
          --#{$prefix}stepper-mobile-step-head-padding-x: #{$stepper-mobile-step-head-padding-x};
          --#{$prefix}stepper-mobile-head-icon-height: #{$stepper-mobile-head-icon-height};
          --#{$prefix}stepper-mobile-head-icon-width: #{$stepper-mobile-head-icon-width};
          --#{$prefix}stepper-mobile-content-top: #{$stepper-mobile-content-top};
          --#{$prefix}stepper-mobile-active-head-icon-bg: #{$stepper-mobile-active-head-icon-bg};
          --#{$prefix}stepper-mobile-completed-head-icon-bg: #{$stepper-mobile-completed-head-icon-bg};
          --#{$prefix}stepper-head-icon-bg: #{$stepper-head-icon-bg};
          --#{$prefix}stepper-head-icon-color: #{$stepper-head-icon-color};
          --#{$prefix}stepper-completed-head-icon-bg: #{$stepper-completed-head-icon-bg};
          --#{$prefix}stepper-completed-head-icon-color: #{$stepper-completed-head-icon-color};
          --#{$prefix}stepper-active-head-icon-bg: #{$stepper-active-head-icon-bg};
          --#{$prefix}stepper-active-head-icon-color: #{$stepper-active-head-icon-color};
          --#{$prefix}stepper-invalid-head-icon-bg: #{$stepper-invalid-head-icon-bg};
          --#{$prefix}stepper-invalid-head-icon-color: #{$stepper-invalid-head-icon-color};
          --#{$prefix}stepper-disabled-head-color: #{$stepper-disabled-head-color};
          --#{$prefix}stepper-disabled-head-icon-bg: #{$stepper-disabled-head-icon-bg};
          --#{$prefix}stepper-disabled-head-icon-color: #{$stepper-disabled-head-icon-color};
          --#{$prefix}stepper-mobile-head-padding-y: #{$stepper-mobile-head-padding-y};
          --#{$prefix}stepper-mobile-head-padding-x: #{$stepper-mobile-head-padding-x};
          --#{$prefix}stepper-mobile-footer-height: #{$stepper-mobile-footer-height};
          --#{$prefix}stepper-back-btn-i-margin-right: #{$stepper-back-btn-i-margin-right};
          --#{$prefix}stepper-next-btn-i-margin-left: #{$stepper-next-btn-i-margin-left};
          --#{$prefix}stepper-mobile-progress-bar-height: #{$stepper-mobile-progress-bar-height};
          --#{$prefix}stepper-mobile-progress-height: #{$stepper-mobile-progress-height};
          --#{$prefix}stepper-mobile-progress-background-color: #{$stepper-mobile-progress-background-color};
          
        
    

SCSS variables

        
            
        // Steps
        $steps-transition: height 0.2s ease-in-out;
        
        $steps-step-after-left: 2.45rem;
        $steps-step-after-width: 1px;
        $steps-step-after-margin-top: 0.5rem;
        $steps-step-after-bg: #dfdfdf;
        
        $steps-content-padding-y: 1.5rem;
        
        $steps-head-vertical-padding-top: 1.5rem;
        $steps-head-vertical-padding-x: 1.5rem;
        
        $steps-head-icon-vertical-margin-right: 0.75rem;
        
        $steps-head-line-height: 1.3;
        $steps-head-hover-bgc: rgba(0, 0, 0, 0.025);
        
        $steps-head-text-color: $text-muted;
        $steps-head-text-after-font-size: 0.8rem;
        
        $steps-head-icon-font-size: 0.875rem;
        $steps-head-icon-width: 1.938rem;
        $steps-head-icon-height: 1.938rem;
        $steps-head-icon-font-weight: 500;
        
        $steps-active-head-text-font-weight: 500;
        
        // Stepper
        $stepper-padding-x: 1rem;
        
        $stepper-step-height: 4.5rem;
        
        $stepper-step-head-padding-left: 1.5rem;
        $stepper-step-head-padding-right: 1.5rem;
        $stepper-step-head-height: 1px;
        $stepper-step-head-bg: rgba(0, 0, 0, 0.1);
        $stepper-step-head-margin-right: 0.5rem;
        $stepper-step-head-margin-left: 0.5rem;
        
        $stepper-head-icon-margin-y: 1.5rem;
        $stepper-head-icon-margin-right: 0.5rem;
        
        $stepper-vertical-step-top: 3.25rem;
        $stepper-vertical-step-height: calc(100% - 2.45rem);
        $stepper-vertical-content-padding-left: 3.75rem;
        $stepper-vertical-content-transition: height 0.3s ease-in-out, margin-top 0.3s ease-in-out,
          margin-bottom 0.3s ease-in-out, padding-top 0.3s ease-in-out, padding-bottom 0.3s ease-in-out;
        $stepper-vertical-head-padding-bottom: 1.5rem;
        
        $stepper-mobile-step-margin-y: 1rem;
        $stepper-mobile-step-head-padding-x: 0.25rem;
        $stepper-mobile-head-icon-height: 0.5rem;
        $stepper-mobile-head-icon-width: 0.5rem;
        $stepper-mobile-content-top: 2.56rem;
        $stepper-mobile-active-head-icon-bg: rgb(55, 111, 200);
        $stepper-mobile-completed-head-icon-bg: rgb(19, 150, 71);
        
        $stepper-head-icon-bg: rgb(235, 237, 239);
        $stepper-head-icon-color: rgb(64, 70, 79);
        
        $stepper-completed-head-icon-bg: rgb(214, 240, 224);
        $stepper-completed-head-icon-color: rgb(13, 104, 50);
        
        $stepper-active-head-icon-bg: rgb(223, 231, 246);
        $stepper-active-head-icon-color: rgb(44, 88, 160);
        
        $stepper-invalid-head-icon-bg: rgb(249, 225, 229);
        $stepper-invalid-head-icon-color: rgb(175, 35, 58);
        
        $stepper-disabled-head-color: #808080;
        $stepper-disabled-head-icon-bg: #e6e6e6;
        $stepper-disabled-head-icon-color: #808080;
        
        $stepper-mobile-head-padding-y: 0.5rem;
        $stepper-mobile-head-padding-x: 1rem;
        $stepper-mobile-footer-height: 2.5rem;
        
        $stepper-back-btn-i-margin-right: 0.5rem;
        $stepper-next-btn-i-margin-left: 0.5rem;
        
        $stepper-mobile-progress-bar-height: 0.3rem;
        $stepper-mobile-progress-height: 0.3rem;
        $stepper-mobile-progress-background-color: $gray-300;